var __MALL_ORDER_PERMISSIONS = {
    "Order": {
        "Order": {
            "list": {
                "name": "查看订单",
                "value": "010101",
                "isNeed": "true"
            },
            "detail": {
                "name": "订单详情",
                "value": "010102"
            },
            "audit": {
                "name": "订单审核",
                "value": "010104"
            },
            "edit": {
                "name": "订单修改",
                "value": "010105"
            },
            "stop": {
                "name": "订单中止",
                "value": "010106"
            },
            "obsolete": {
                "name": "订单作废",
                "value": "010107"
            },
            "stockout": {
                "name": "商品出库",
                "value": "010108"
            },
            "deliver": {
                "name": "商品发货",
                "value": "010112"
            },
            "obsoleteStockout": {
                "name": "作废出库",
                "value": "010109"
            },
            "log": {
                "name": "订单日志",
                "value": "010110"
            },
            "printExport": {
                "name": "打印导出",
                "value": "010111"
            }
        },
        "StockOutDeliver": {
            "list": {
                "name": "查看",
                "value": "010201",
                "isNeed": "true"
            },
            "printExport": {
                "name": "打印导出",
                "value": "010202"
            }
        },
        "Return": {
            "list": {
                "name": "查看退单",
                "value": "010301",
                "isNeed": "true"
            },
            "detail": {
                "name": "退单详情",
                "value": "010302"
            },
            "audit": {
                "name": "退单审核",
                "value": "010303"
            },
            "obsolete": {
                "name": "退单作废",
                "value": "010304"
            },
            "confirm": {
                "name": "确认收货",
                "value": "010306"
            },
            "printExport": {
                "name": "打印导出",
                "value": "010305"
            }
        },
        "ReplaceOrder": {
            "add": {
                "name": "新增",
                "value": "010401"
            }
        }
    },
    "Finance": {
        "Receive": {
            "list": {
                "name": "查看",
                "value": "020101",
                "isNeed": "true"
            },
            "detail": {
                "name": "详情",
                "value": "020104"
            },
            "confirm": {
                "name": "确认收款",
                "value": "020102"
            },
            "printExport": {
                "name": "打印导出",
                "value": "020103"
            }
        },
        "Advance": {
            "list": {
                "name": "查看",
                "value": "020201",
                "isNeed": "true"
            },
            "detail": {
                "name": "详情",
                "value": "020202"
            },
            "cashOutManage": {
                "name": "提现管理",
                "value": "020203"
            },
            "cashOut": {
                "name": "支付提现",
                "value": "020204"
            }
        },
        "SalesRebate": {
            "list": {
                "name": "查看",
                "value": "020301",
                "isNeed": "true"
            },
            "add": {
                "name": "新增",
                "value": "020302"
            },
            "audit": {
                "name": "审核",
                "value": "020304"
            },
            "delete": {
                "name": "删除",
                "value": "020303"
            }
        },
        "Reconciliation": {
            "list": {
                "name": "查看",
                "value": "020401",
                "isNeed": "true"
            }
        }
    },
    "Product": {
        "Product": {
            "list": {
                "name": "查看",
                "value": "030101",
                "isNeed": "true"
            },
            "add": {
                "name": "新增",
                "value": "030102"
            },
            "edit": {
                "name": "编辑",
                "value": "030103"
            },
            "delete": {
                "name": "删除",
                "value": "030104"
            }
        }
    },
    "Contact": {
        "Contact": {
            "list": {
                "name": "查看",
                "value": "040101",
                "isNeed": "true"
            },
            "add": {
                "name": "新增",
                "value": "040102"
            },
            "edit": {
                "name": "编辑",
                "value": "040103"
            },
            "delete": {
                "name": "删除",
                "value": "040104"
            },
            "shieldProduct": {
                "name": "屏蔽商品",
                "value": "040105"
            }
        },
        "WaitContact": {
            "list": {
                "name": "查看待审核客户",
                "value": "040106",
                "isNeed": "true"
            },
            "audit": {
                "name": "审核注册客户",
                "value": "040107"
            },
            "delete": {
                "name": "删除注册客户",
                "value": "040108"
            }
        },
        "ContactGrade": {
            "list": {
                "name": "查看",
                "value": "040201",
                "isNeed": "true"
            },
            "edit": {
                "name": "编辑",
                "value": "040202"
            }
        },
        "OpenRegister": {
            "list": {
                "name": "查看",
                "value": "040301",
                "isNeed": "true"
            },
            "edit": {
                "name": "编辑",
                "value": "040302"
            }
        }
    },
    "Promotion": {
        "DiscountPromotion": {
            "list": {
                "name": "查看",
                "value": "050201",
                "isNeed": "true"
            },
            "add": {
                "name": "新增",
                "value": "050202"
            },
            "edit": {
                "name": "编辑",
                "value": "050203"
            },
            "obsolete": {
                "name": "作废",
                "value": "050204"
            },
            "delete": {
                "name": "删除",
                "value": "050205"
            }
        },
        "AssemblePromotion": {
            "list": {
                "name": "查看",
                "value": "050401",
                "isNeed": "true"
            },
            "add": {
                "name": "新增",
                "value": "050402"
            },
            "edit": {
                "name": "编辑",
                "value": "050403"
            },
            "obsolete": {
                "name": "作废",
                "value": "050404"
            },
            "delete": {
                "name": "删除",
                "value": "050405"
            }
        },
        "GiftPromotion": {
            "list": {
                "name": "查看",
                "value": "050501",
                "isNeed": "true"
            },
            "add": {
                "name": "新增",
                "value": "050502"
            },
            "edit": {
                "name": "编辑",
                "value": "050503"
            },
            "obsolete": {
                "name": "作废",
                "value": "050504"
            },
            "delete": {
                "name": "删除",
                "value": "050505"
            }
        },
        "SuitePromotion": {
            "list": {
                "name": "查看",
                "value": "050601",
                "isNeed": "true"
            },
            "add": {
                "name": "新增",
                "value": "050602"
            },
            "edit": {
                "name": "编辑",
                "value": "050603"
            },
            "delete": {
                "name": "删除",
                "value": "050604"
            }
        },
        "FullCutPromotion": {
            "list": {
                "name": "查看",
                "value": "050701",
                "isNeed": "true"
            },
            "add": {
                "name": "新增",
                "value": "050702"
            },
            "edit": {
                "name": "编辑",
                "value": "050703"
            },
            "obsolete": {
                "name": "作废",
                "value": "050704"
            },
            "delete": {
                "name": "删除",
                "value": "050705"
            }
        }
    },
    "PickDelivery": {
        "PickByOrder": {
            "list": {
                "name": "查看",
                "value": "080101",
                "isNeed": "true"
            },
            "print": {
                "name": "打印",
                "value": "080102"
            }
        },
        "PickByProduct": {
            "list": {
                "name": "查看",
                "value": "080201",
                "isNeed": "true"
            },
            "print": {
                "name": "打印",
                "value": "080202"
            }
        },
        "PickByCustomer": {
            "list": {
                "name": "查看",
                "value": "080301",
                "isNeed": "true"
            },
            "print": {
                "name": "打印",
                "value": "080302"
            }
        },
        "DeliverCustomer": {
            "listByZone": {
                "name": "查看",
                "value": "080701",
                "isNeed": "true"
            },
            "printByZone": {
                "name": "打印",
                "value": "080702"
            },
            "list": {
                "name": "查看",
                "value": "080601",
                "isNeed": "true"
            },
            "print": {
                "name": "打印",
                "value": "080602"
            }
        },
        "DeliveryConfig": {
            "list": {
                "name": "查看",
                "value": "080401",
                "isNeed": "true"
            },
            "setDeliverType ": {
                "name": "设置配送方式",
                "value": "080402"
            }
        },
        "DeliverByOrder": {
            "list": {
                "name": "查看",
                "value": "080501",
                "isNeed": "true"
            },
            "print": {
                "name": "打印",
                "value": "080502"
            }
        }
    },
    "Config": {
        "ReceiveConfig": {
            "list": {
                "name": "查看",
                "value": "060201",
                "isNeed": "true"
            },
            "edit": {
                "name": "编辑",
                "value": "060202"
            }
        },
        "SmsConfig": {
            "list": {
                "name": "查看",
                "value": "060301",
                "isNeed": "true"
            },
            "edit": {
                "name": "编辑",
                "value": "060302"
            },
            "charge": {
                "name": "充值",
                "value": "060303"
            }
        },
        "SysConfig": {
            "list": {
                "name": "查看",
                "value": "060401",
                "isNeed": "true"
            },
            "edit": {
                "name": "编辑",
                "value": "060402"
            }
        },
        "WMall": {
            "list": {
                "name": "查看",
                "value": "060501",
                "isNeed": "true"
            }
        },
        "Notice": {
            "list": {
                "name": "查看",
                "value": "050101",
                "isNeed": "true"
            },
            "add": {
                "name": "新增",
                "value": "050102"
            },
            "delete": {
                "name": "删除",
                "value": "050103"
            }
        },
        "Banner": {
            "list": {
                "name": "查看",
                "value": "050301",
                "isNeed": "true"
            },
            "add": {
                "name": "新增",
                "value": "050302"
            },
            "edit": {
                "name": "编辑",
                "value": "050303"
            },
            "delete": {
                "name": "删除",
                "value": "050304"
            }
        },
        "HomeItem": {
            "list": {
                "name": "查看",
                "value": "050801",
                "isNeed": "true"
            },
            "add": {
                "name": "新增",
                "value": "050802"
            },
            "edit": {
                "name": "编辑",
                "value": "050803"
            },
            "delete": {
                "name": "删除",
                "value": "050804"
            }
        }
    },
    "Other": {
        "MallPreview": {
            "list": {
                "name": "查看",
                "value": "070101"
            }
        }
    }
}
/**
 * 权限校验逻辑
 * @param {Object} authorityString权限字符串  080201 格式
 */
function authorityCheckUpdated(authorityString) {
	var userInfoString = localStorage.getItem('ddh_userInfo');
	if(!userInfoString.trim()) {
		return false;
	}
	var userInfoObj = JSON.parse(userInfoString);
	if(!userInfoObj) {
		return false;
	}
	if(userInfoObj['IsAdmin'] || userInfoObj['IsAdminPermission']) {
		return true;
	}
	if(!authorityString.trim()) {
		return true;
	}
	var orAuthorityArray = authorityString.split('||');
	//处理or
	if(orAuthorityArray.length > 1) {
		var result = false;
		for(var i = 0; i < orAuthorityArray.length; i++) {
			result = (result || authorityCheckUpdated(orAuthorityArray[i]));
		}
		return result;
	}
	//处理and
	var andAuthorityArray = authorityString.split('&&');
	if(andAuthorityArray.length > 1) {
		var result = true;
		for(var i = 0; i < andAuthorityArray.length; i++) {
			result = result && authorityCheckUpdated(andAuthorityArray[i]);
		}
		return result;
	}

	var permissionItemsArray = userInfoObj['MallPurview'];
	if(!permissionItemsArray) { //异常情况
		return false;
	}
	var authorityCode = __MALL_ORDER_PERMISSIONS;
	console.log(authorityString)
	var authorityCodesArray = authorityString.split(".");
	for (var i = 0; i < authorityCodesArray.length; i++) {
		authorityCode = authorityCode[authorityCodesArray[i]]
	}
	//var authorityCode = __MALL_ORDER_PERMISSIONS[authorityString];//用权限字符串获得权限码
	if(permissionItemsArray.indexOf(authorityCode.value) < 0) { //未找到权限
		return false;
	}
	return true;
}
//执行权限检验
function excuteAuthorityCheck() {
	var hiddenDom = document.querySelectorAll('.app-hidden')
	for(var i = 0; i < hiddenDom.length; i++) {
		if(!hiddenDom[i].hasAttribute('data-permission')) {
			continue;
		}
		var permissionString = hiddenDom[i].getAttribute('data-permission')
		if(authorityCheckUpdated(permissionString)) {
			hiddenDom[i].classList.remove('app-hidden');
		} else {
			var _parentElement = hiddenDom[i].parentNode;
			if(_parentElement) {
				_parentElement.removeChild(hiddenDom[i]);
			}
		}
	}
}
(function() {
	excuteAuthorityCheck(); //页面引用之后立即执行校验
})();
