////////获取当前页面最近一笔销售金额，资金流水类等数据的方法
////////1:销售，2:采购，3:资金流水
function erpLittleDataGet() {
	var refreshDataArray = document.querySelectorAll('.has-little-data');
	for(var i = 0; i < refreshDataArray.length; i++) {
		var targetObj = refreshDataArray[i];
		var type = targetObj.getAttribute('data-refresh-data');
		getLittleData(targetObj, type);
	}
}

function getLittleData(targetObj, type) {
	sendConfigRequest({
		'requestUri': '/home/getHomeInfo',
		'requestType': 'get',
		'requestShowLoading': true,
		'requestData': {
			type: type
		},
		'requestSuccessCallback': function(data, status, xhr) {
			if(!data.success) {
				mui.toast(data.message);
				return
			}
			switch(Number(type)) {
				case 1://销售
				case 2://采购
					var showAmount = numberFormat(data.data.value, 2, '.', '');
					if(Number(type) == 2 && !authorityCheck("OTHER.OTHER_COST.VIEW")){
						showAmount = "***";
					}
					targetObj.querySelector('span.amount-normal').innerText = showAmount;
					break;
				case 3://资金流水
					targetObj.innerHTML = '最近一笔:'+data.data.name+'<span class="amount-normal">'+numberFormat(data.data.value, 2, '.', '')+'</span>';
					break;
				default:
					break;
			}

			pullRefreshDown_getData.refresh_UI();
		},
		'requestFailCallback': function(xhr, type, errorThrown) {}
	});
}