/////模版辅助函数注册
template.helper('numberFormat', function(number, decimals, decPoint, thousandsSep) {
	return numberFormat(number, decimals, decPoint, thousandsSep);
})
template.helper('getYearFromDateStr', function(dateStr) {
	return getYearFromDateStr(dateStr);
})
template.helper('getDayFromDateStr', function(dateStr) {
	return getDayFromDateStr(dateStr);
});
template.helper('handleDate', function(dateStr) {
	return handleDate(dateStr);
});
template.helper('getStrDateFormatStrDate', function(dateStr, param2, param3) {
	return getStrDateFormatStrDate(dateStr);
});
template.helper('authorityCheck', function(param) {
	return authorityCheck(param);
});
template.helper('checkDateExist', function(data) {
	return checkDateExist(data);
});
template.helper('showMultiUnits', function(multiUnits, stockQty, selectedUnitId) { //格式化库存数量
	return showMultiUnits(multiUnits, stockQty, selectedUnitId);
});
function checkDateExist(date) {
	if(!hasCategoriedDateList) {
		hasCategoriedDateList = new HashMap()
	}
	if(hasCategoriedDateList.has(getStrDateFormatStrDate(date))) {
		return true
	}
	hasCategoriedDateList.set(getStrDateFormatStrDate(date));
	return false;
}
/**
 * 获取年份字符串
 * @param {Object} dateStr
 * 返回格式{year:----,day:-----}
 */
function getYearFromDateStr(dateStr) {
	if(!dateStr) {
		return '----';
	}
	var dayAndTime = dateStr.split(' ');
	var day = dayAndTime[0].split('-');
	return day[0];;
}

function getDayFromDateStr(dateStr) {
	if(!dateStr) {
		return '-----';
	}
	var dayAndTime = dateStr.split(' ');
	var day = dayAndTime[0].split('-');
	return day[1] + '-' + day[2];
}

function handleDate(str) {
	if(!str) {
		return '-'
	}
	var strArray = str.split(" ");
	if(strArray[1] && strArray[1] == '00:00:00') {
		return strArray[0];
	}
	return str;
}