/**
 * Created by 0000 on 16/11/21.
 */
var indexWaiting;
/**
 * H5压缩
 */
function resizeImageWeb(reSizeConfig){
    indexWaiting=showWaiting(true);
    console.log("indexWaiting:"+indexWaiting);
    var defaultConfig = {
        'path': '',//图片路径
        // 'FileName': '',//图片名字
        // 'os': '',//运行环境
        'getDataFromAPICallback': function (data, status, xhr) {
        },
        'requestFailCallback': function (xhr, type, errorThrown) {
        }
    };
    var reSizeConfigUse;
    if (typeof(reSizeConfig) == "object") {
        reSizeConfigUse = mui.extend({}, defaultConfig, reSizeConfig);
    } else if (typeof(reSizeConfig) == "string") {
        reSizeConfigUse={};
        reSizeConfigUse.path = reSizeConfig;
    }else {
        return;
    }
    // console.log("reSizeConfig.FileName:"+reSizeConfigUse.FileName);
    // console.log("reSizeConfigUse.path:"+reSizeConfigUse.path);
    lrz(reSizeConfigUse.path, {
        width: 1200
    })
        .then(function (rst) {
            var img = new Image(),
                resultSize = toFixed2(rst.fileLen / 1024);
                // scale = parseInt(100 - (resultSize / sourceSize * 100));
            console.log("压缩后 resultSize："+resultSize+"kb");
             if(resultSize>100*1024){
                    mui.alert("你上传的图片太大了!");
                    return rst;
             }
            img.src = rst.base64;
            var FileName=reSizeConfigUse.FileName!=null?reSizeConfigUse.FileName:reSizeConfigUse.path.substring(reSizeConfigUse.path.lastIndexOf("/")+1);
            FileName=FileName.toLowerCase( );
            var requestData={"FileName":FileName,"FileData":rst.base64};
            var APIFunctionConfig= mui.extend({}, reSizeConfigUse);
            APIFunctionConfig.requestData=requestData;
            console.log(rst.formData)
            APIPostImageFile(APIFunctionConfig);

            return rst;
        });

}
function toFixed2 (num) {
    return parseFloat(+num.toFixed(2));
}
/**
 * 图片上传(base64数据)
 * @param config
 * config.apiUrl
 * @constructor
 */
function APIPostImageFile(config) {
    var defaultConfig = {
        "apiType":0,
        'apiUrl': (isDebug ? __TEST_URL : __FORMAL_URL)+"/api/upload/uploadImg",//接口基础地址
        'requestData': '',//图片base64数据和文件名
        // 'size': '100',//图片显示路径,可空
        'getDataFromAPICallback': function (data, status, xhr) {
        },
        'requestFailCallback': function (xhr, type, errorThrown) {
        }
    };
    var configUse;
    if (typeof(config) == "object") {
        configUse = mui.extend({}, defaultConfig, config);
    }else {
        return;
    }
    // configUse.requestData.maxWidth=1000;
    // console.log("configUse.requestData:"+configUse.requestData);
    console.log("configUse.requestData.FileName:"+configUse.requestData.FileName);
    console.log("configUse.requestData.FileData.length:"+configUse.requestData.FileData.length);
    // console.log("configUse.requestData.FileData:"+configUse.requestData.FileData);
    var formData=getFormData(configUse.requestData.FileName,configUse.requestData.FileData);
    /*原生ajax*/
    var xhr = null; //得到xhr对象
    if(XMLHttpRequest){
        xhr = new XMLHttpRequest();
    }else{
        xhr = new ActiveXObject("Microsoft.XMLHTTP");
    }
    xhr.open("post", configUse.apiUrl+"?maxWidth=1200", true);//设置提交方式，url，异步提交
    /*Content-Encoding:gzip*/
    // xhr.setRequestHeader("Accept-Encoding","gzip, deflate");
    var SessionKey = app_userManage.getUserInfo_fromLocalStorage(_SESSION_KEY);
	if(SessionKey && SessionKey != '') {
		xhr.setRequestHeader("sessionKey", SessionKey);
	}
	if(mui.os.android) {
		 xhr.setRequestHeader("AppKey", "72b7c8e3b3854668a2d5b04f61add104");
	} else if(mui.os.ios) {
		 xhr.setRequestHeader("AppKey", "c8a21b361f114de1b34a54c7b5d6ccdd");
	} else {
		 xhr.setRequestHeader("AppKey", "2b23dce10ba745c98d4d38cfdbe83bd4");
	}
    xhr.setRequestHeader("TimeStamp",new Date().getTime().toString().substr(0, 10));
    xhr.onload = function ()
    {
        switch (xhr.status){
            case 200:
                // 上传成功
                var data = xhr.responseText;    //得到返回值
                console.log("----------data:"+data);
                var responseData = JSON.parse(data);
                console.log("----------responseData.msg:"+responseData.msg);
                if(configUse.getDataFromAPICallback(responseData.data, responseData.success, responseData.message, responseData.code)){
                    return true;
                }
                // if(configUse.apiType==1){
                //     if(configUse.getDataFromAPICallback(responseData.data, responseData.success, responseData.message, responseData.code)){
                //         return true;
                //     }
                // }else{
                //     if(configUse.getDataFromAPICallback(responseData.data, responseData.Success, responseData.Message, responseData.Code)){
                //         return true;
                //     }
                // }

                break;
            case 413:
                mui.alert("上传图片过大");
                break;
            default:
                // 处理其他情况
                mui.alert(xhr.responseText);
                break;
        }

        closeWaiting(indexWaiting);
        console.log("indexWaiting:"+indexWaiting);

    }
    xhr.onerror = function (xhr, type, errorThrown)
    {
        closeWaiting(indexWaiting);
        console.log("indexWaiting:"+indexWaiting);
        console.log("requestFailCallback errorThrown:"+errorThrown);

    };
    xhr.send(formData);
    return;
}

/**
 * 将base64转换成二进制图片（Blob）
 * @param base64Data
 * @returns {*}
 */
function dataURItoBlob(base64Data) {
    var byteString;
    if (base64Data.split(',')[0].indexOf('base64') >= 0)
        byteString = atob(base64Data.split(',')[1]);
    else
        byteString = unescape(base64Data.split(',')[1]);
    var mimeString = base64Data.split(',')[0].split(':')[1].split(';')[0];
    var ia = new Uint8Array(byteString.length);
    for (var i = 0; i < byteString.length; i++) {
        ia[i] = byteString.charCodeAt(i);
    }
    return new Blob([ia], {type:mimeString});
}

/**
 * 通过base64获取 构造的formData数据
 * @param imageBase64
 * @returns {*}
 */
function getFormData(fileName,imageBase64) {
    var blob = dataURItoBlob(imageBase64); // 上一步中的函数
    var canvas = document.createElement('canvas');
    // var dataURL = canvas.toDataURL('image/jpeg', 0.5);
    // var formData = new FormData(document.forms[0]);
    var formData = new FormData();
    formData.append("file", blob, fileName);
    return formData;
}
