/**
 * Created by lxf on 2016/3/8.
 */
var pullRefreshDown_getData;//下拉刷新回调函数变量 return true 拦截后续调用，false 不拦截
var pullRefreshUp_getData;//上拉刷新回调函数变量 return true 拦截后续调用，false 不拦截
var onResetPositionCall;//滚动为止恢复回调
var onResetPositionCallTask=-1;
var myScroll;
function initUI_pullRefresh() {
    if (!pullRefreshDown_getData && !pullRefreshUp_getData) {
        return;
    }
    var ui_h_pullHint = 40;
    var status_cur = 0;//0=普通，1=下拉，2=上拉
    var status_next = 0;//0=普通，1=下拉，2=上拉
    var
        upIcon = document.getElementById("up-icon"),
        downIcon = document.getElementById("down-icon");
    var pullDown_msg = document.getElementById("pullDown-msg");
    var pullUp_msg = document.getElementById("pullUp-msg");
    var scroller_pullUp = document.getElementById("scroller-pullUp");

    /*修改源码部分----------------------------*/
    var handleEvent_src=IScroll.prototype.handleEvent;
    IScroll.prototype.handleEvent=function(e){
        // console.log("handleEvent e.type:"+e.type);
        handleEvent_src.call(this,e);
        //if(e.touches!=null&&e.touches[0]!=null){
        //    console.log("handleEvent e.touches[0].pageY:"+e.touches[0].pageY);
        //    console.log("handleEvent e.touches[0].screenY:"+e.touches[0].screenY);
        //}
        //console.log("this.wrapper.offsetTop:"+this.wrapper.offsetTop);
        //console.log("this.wrapperHeight:"+this.wrapperHeight);
        //console.log("navigator.userAgent:"+navigator.userAgent);
        //console.log("navigator.vendor:"+navigator.vendor);
        if (navigator.userAgent.indexOf("Mobile") > -1&&navigator.userAgent.indexOf("Chrome") == -1) {
            // console.log("ios");
            if (e.changedTouches!=null&&e.changedTouches[0]!=null) {
                if(e.changedTouches[0].pageY <= 0){
                    // console.log("e.changedTouches[0].pageY <= 0");
                    e.preventDefault();
                    //window.dispatchEvent(new Event("touchEnd"));
                    this._end(e);
                }else if(e.changedTouches[0].pageY-this.wrapper.offsetTop>=this.wrapperHeight){
                    // console.log("(e.changedTouches[0].pageY-this.wrapper.offsetTop>=this.wrapperHeight)");
                    e.preventDefault();
                    this._end(e);
                }
            }
        }
    };
    var refresh_src= IScroll.prototype.refresh;
    IScroll.prototype.refresh=function(){
        // console.log('refresh begin');
        refresh_src.call(this);
        this.hasVerticalScroll=true;
        //console.log("refresh end");
    };
    var v_pullRefresh_wrapperID=document.querySelector('.pullRefresh_wrapper').id;
    if(v_pullRefresh_wrapperID==null||v_pullRefresh_wrapperID==""){
        v_pullRefresh_wrapperID="pullRefresh_wrapper";
        document.querySelector('.pullRefresh_wrapper').id=v_pullRefresh_wrapperID;
    }
    myScroll = new IScroll('#'+v_pullRefresh_wrapperID, {
        probeType: 3,
        mouseWheel: true,
        // preventDefaultException: { tagName: /^(INPUT|TEXTAREA|BUTTON|SELECT|A)$/ },
        // preventDefault:false,
        //fixedScrollbar:true,
        //bounce:true
    });
    myScroll.resetPosition = function (time, isPull) {
        // console.log("resetPosition begin time:"+time+",isPull:"+isPull);
        var x = this.x,
            y = this.y;
        time = time || 0;

        if (!this.hasHorizontalScroll || this.x > 0) {
            x = 0;
        } else if (this.x < this.maxScrollX) {
            x = this.maxScrollX;
        }

        if (!this.hasVerticalScroll || this.y > 0) {
            y = 0;
        } else if (this.y < this.maxScrollY) {
            y = this.maxScrollY;
        }
        if(!!onResetPositionCall){
            // console.log("!!onResetPositionCall");
            onResetPositionCall();
            if(onResetPositionCallTask!=-1){
                // console.log(" clearTimeout(onResetPositionCallTask)");
                clearTimeout(onResetPositionCallTask);
            }
            onResetPositionCallTask=setTimeout(onResetPositionCall(),300);
        }
        if (x == this.x && y == this.y) {
            //console.log("resetPosition end");
            return false;
        }

        if (!!pullRefreshDown_getData) {
            if (this.y > 0 && this.y > ui_h_pullHint) {
                // console.log("resetPosition isPull pullRefreshDown");
                this.scrollTo(x, ui_h_pullHint, 0, this.options.bounceEasing);
                pullRefreshDown();
                //console.log("resetPosition end");
                return true;
            }
        }
        if (!!pullRefreshUp_getData) {
            if (this.y < this.maxScrollY && this.maxScrollY - this.y > ui_h_pullHint) {
                //console.log("resetPosition isPull pullRefreshUp");
                this.scrollTo(x, this.maxScrollY - ui_h_pullHint, 0, this.options.bounceEasing);
                pullRefreshUp();
                //console.log("resetPosition end");
                return true;
            }
        }
        this.scrollTo(x, y, time, this.options.bounceEasing);
        // console.log("resetPosition end");
        return true;

    };
    /*----------------------------修改源码部分*/
    myScroll.on("scroll", function () {
        // console.log('scroll');
        //console.log('scroll this.pointY:'+this.pointY);
        //console.log('scroll this.hasVerticalScroll:'+this.hasVerticalScroll+";this.y :"+this.y+";this.maxScrollY:"+this.maxScrollY+"----this.wrapperHeight:"+this.wrapperHeight+";this.scrollerHeight:"+this.scrollerHeight+";status_next:"+status_next);
        document.activeElement?document.activeElement.blur():'';
        var y = this.y;
        if (!!pullRefreshDown_getData) {
            var downHasClass = downIcon.classList.contains("rotate");
//            console.log("scroll y:" + y + ",maxScrollY:" + this.maxScrollY);
            if (y >= ui_h_pullHint) {
                !downHasClass && downIcon.classList.add("rotate");
                pullDown_msg.innerHTML = "松开刷新";
                //status_next=1;
                return "";
            } else if (y < ui_h_pullHint && y > 0) {
                pullDown_msg.innerHTML = "下拉刷新数据";
                downHasClass && downIcon.classList.remove("rotate");
                //status_next=0;
                return "";
            }
        }

        if (!!pullRefreshUp_getData) {
            var maxY = this.maxScrollY - y;
            var upHasClass = upIcon.classList.contains("rotate");
            if (maxY >= ui_h_pullHint) {
                !upHasClass && upIcon.classList.add("rotate");
                pullUp_msg.innerHTML = "松开加载";
                scroller_pullUp.style.bottom = (-ui_h_pullHint + maxY) + "px";
                //status_next=2;
                return "";
            } else if (maxY < ui_h_pullHint && maxY >= 0) {
                upHasClass && upIcon.classList.remove("rotate");
                pullUp_msg.innerHTML = "上拉加载更多";
                scroller_pullUp.style.bottom = (-ui_h_pullHint + maxY) + "px";
                //status_next=0;
                return "";
            }
        }


    });
    myScroll.on('scrollEnd', function () {
        //console.log('scrollEnd this.hasVerticalScroll:' + this.hasVerticalScroll + ";this.y :" + this.y + ";this.maxScrollY:" + this.maxScrollY + "----this.wrapperHeight:" + this.wrapperHeight + ";this.scrollerHeight:" + this.scrollerHeight + ";status_next:" + status_next);
    });
    function update_status_next() {
        //console.log("update_status_next begin");
        switch (status_next) {
            case 0:
                break;
            case 1:
                if (!!pullRefreshDown_getData) {
                    pullRefreshDown();
                }
                break;
            case 2:
                if (!!pullRefreshUp_getData) {
                    pullRefreshUp();
                }
                break;
        }
        //console.log("update_status_next end");
    }

    myScroll.on('scrollCancel', function () {
        //console.log('scrollCancel');
    });
    function pullRefreshDown() {
        //console.log("pullRefreshDown begin");
        pullDown_msg.innerHTML = "正在刷新";
        downIcon.classList.remove("mui-icon-arrowthinup");
        downIcon.classList.add("refreshing");
        downIcon.classList.add("mui-icon-refresh");
        if (pullRefreshDown_getData()) {
            return "";
        } else {
            refresh_UI_pullRefreshDown();
        }
        //console.log("pullRefreshDown end");
    }

    if (!!pullRefreshDown_getData) {
        pullRefreshDown_getData.refresh_UI = refresh_UI_pullRefreshDown;
    }
    function pullRefreshUp() {
        //console.log("pullRefreshUp begin");
        upIcon.classList.remove("mui-icon-arrowthinup");
        upIcon.classList.add("refreshing");
        upIcon.classList.add("mui-icon-refresh");
        pullUp_msg.innerHTML = "正在加载";
        scroller_pullUp.style.bottom = "0px";
        if (pullRefreshUp_getData()) {
            return "";
        } else {
            refresh_UI_pullRefreshUp();
        }
        //console.log("pullRefreshUp end");
    }

    if (!!pullRefreshUp_getData) {
        pullRefreshUp_getData.refresh_UI = refresh_UI_pullRefreshUp;
    }

    function refresh_UI_pullRefreshDown() {
        //console.log("refresh_UI_pullRefreshDown begin");
        downIcon.classList.remove("refreshing");
        downIcon.classList.remove("mui-icon-refresh");
        downIcon.classList.add("mui-icon-arrowthinup");
        myScroll.refresh();
        //                myScroll.scrollTo(0, 0, 600, myScroll.options.bounceEasing);
        //console.log("refresh_UI_pullRefreshDown end");
    }

    function refresh_UI_pullRefreshUp() {
        //console.log("refresh_UI_pullRefreshUp begin");
        upIcon.classList.remove("refreshing");
        upIcon.classList.remove("mui-icon-refresh");
        upIcon.classList.add("mui-icon-arrowthinup");
        //console.log("refresh_UI_pullRefreshUp ing1 scroller_pullUp.style.bottom:"+scroller_pullUp.style.bottom);
        scroller_pullUp.style.bottom = -ui_h_pullHint + "px";
        //console.log("refresh_UI_pullRefreshUp ing2 scroller_pullUp.style.bottom:"+scroller_pullUp.style.bottom);
//            myScroll.scrollTo(0, myScroll.maxScrollY, 600, myScroll.options.bounceEasing);
        myScroll.refresh();
        //console.log("refresh_UI_pullRefreshUp end scroller_pullUp.style.bottom:"+scroller_pullUp.style.bottom);
        //console.log("refresh_UI_pullRefreshUp end");
    }
}