/**
 *用于本地存储参数的工具类 
 */

QY_setLocalParam = function(idString, obj) {
	if(!idString || !obj || typeof(idString) !== 'string') {
		throw '参数为空或不合法，传递失败';
		return;
	}
	localStorage.setItem('QY_param_' + idString, JSON.stringify(obj));
}
QY_getLocalParam = function(idString, obj) {
	if(!idString || typeof(idString) !== 'string') {
		throw '参数为空或不合法，读取失败';
		return;
	}
	return JSON.parse(localStorage.getItem('QY_param_' + idString));
}
QY_removeLocalParam = function(idString) {
	if(!idString || typeof(idString) !== 'string') {
		throw '参数为空或不合法，删除失败';
		return;
	}
	JSON.parse(localStorage.removeItem('QY_param_' + idString));
}