//H5与底层交互的公共插件接口
document.addEventListener("plusready", function() {
	var _FLAG_CLASS = "H5BridgeFunctions",
		B = window.plus.bridge;
	var H5BridgeFunctions = {
		//退出应用
		PluginExitApp: function(data, successCallback, errorCallback) {
			var success = typeof successCallback !== 'function' ? null : function(args) {
				successCallback(args);
			};
			var fail = typeof errorCallback !== 'function' ? null : function(error) { //error是一个错误JSON对象
				errorCallback(error);
			};
			callbackID = B.callbackId(success, fail);
			return B.exec(_FLAG_CLASS, "pluginBridgeExit", [callbackID, data]);
		}
	};
	window.plus.H5BridgeFunctions = H5BridgeFunctions;
}, true);