//通用
var commonConfig = {
	printAfterAdd: false, //开单后立即打印
	printSize: {
		"58mm": {
			text: "58mm",
			value: true,
			field: "58mm"
		},
		"80mm": {
			text: "80mm",
			value: false,
			field: "80mm"
		},
		"PrickBase": {
			text: "针式基础模板(241mm*280mm)",
			value: false,
			field: "PrickBase",
			paperType:1//1：无等分，2：二等分，3：三等分
		}
	}, //58mm,80mm,PrickBase(针式基础）
	pageHead: "", //页眉，默认为空
	pageFooter: "", //页脚，默认为空
	showField: { //显示哪些字段

	}
}

//索引默认模板
var tplIndex = {
	"销售单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "销售单", //单据名称，默认为当前单据的名称
			showField: {
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputeName"
				},
				"discount": {
					text: "折扣率（折扣额）",
					value: true,
					field: ""
				},
				"warehouseName": {
					text: "出库仓库",
					value: true,
					field: "warehouseName"
				},
				"taxTotal": {
					text: "折后税额",
					value: true,
					field: "taxTotal"
				},
				"otherFee": {
					text: "其他费用",
					value: true,
					field: "otherFee"
				},
				"accountName": {
					text: "结算账户",
					value: true,
					field: "accountName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"productMemo": {
					text: "商品备注（针式）",
					value: false,
					field: "memo"
				},
				"propertySpec": {
					text: "规格，属性",
					value: true,
					field: ""
				},
				"barcode": {
					text: "商品编号/条形码",
					value: true,
					field: ""
				},
				"serial": {
					text: "序列号（针式）",
					value: false,
					field: "snNos"
				},
				"contactInfo": {
					text: "联系人电话地址",
					value: false,
					field: "contactInfo"
				}
			}
		}
	},
	"销售订单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "销售订单", //单据名称，默认为当前单据的名称
			showField: {
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputeName"
				},
				"discount": {
					text: "折扣率（折扣额）",
					value: true,
					field: ""
				},
				"warehouseName": {
					text: "出库仓库",
					value: true,
					field: "warehouseName"
				},
				"taxTotal": {
					text: "折后税额",
					value: true,
					field: "taxTotal"
				},
				"otherFee": {
					text: "其他费用",
					value: true,
					field: "otherFee"
				},
				"accountName": {
					text: "结算账户",
					value: true,
					field: "accountName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"productMemo": {
					text: "商品备注（针式）",
					value: false,
					field: "memo"
				},
				"propertySpec": {
					text: "规格，属性",
					value: true,
					field: ""
				},
				"barcode": {
					text: "商品编号/条形码",
					value: true,
					field: ""
				},
				"contactInfo": {
					text: "联系人电话地址",
					value: false,
					field: "contactInfo"
				}
			}
		}
	},
	"销售退货单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "销售退货单", //单据名称，默认为当前单据的名称
			showField: {
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputeName"
				},
				"discount": {
					text: "折扣率（折扣额）",
					value: true,
					field: ""
				},
				"warehouseName": {
					text: "入库仓库",
					value: true,
					field: "warehouseName"
				},
				"taxTotal": {
					text: "折后税额",
					value: true,
					field: "taxTotal"
				},
				"otherFee": {
					text: "其他费用",
					value: true,
					field: "otherFee"
				},
				"accountName": {
					text: "结算账户",
					value: true,
					field: "accountName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"productMemo": {
					text: "商品备注（针式）",
					value: false,
					field: "memo"
				},
				"propertySpec": {
					text: "规格，属性",
					value: true,
					field: ""
				},
				"barcode": {
					text: "商品编号/条形码",
					value: true,
					field: ""
				},
				"serial": {
					text: "序列号（针式）",
					value: false,
					field: "snNos"
				},
				"contactInfo": {
					text: "联系人电话地址",
					value: false,
					field: "contactInfo"
				}
			}
		}
	},
	"零售单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "零售单", //单据名称，默认为当前单据的名称
			showField: {
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputeName"
				},
				"discount": {
					text: "折扣率（折扣额）",
					value: true,
					field: ""
				},
				"warehouseName": {
					text: "出库仓库",
					value: true,
					field: "warehouseName"
				},
				"accountName": {
					text: "结算账户",
					value: true,
					field: "accountName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"productMemo": {
					text: "商品备注（针式）",
					value: false,
					field: "memo"
				},
				"propertySpec": {
					text: "规格，属性",
					value: true,
					field: ""
				},
				"barcode": {
					text: "商品编号/条形码",
					value: true,
					field: ""
				},
				"serial": {
					text: "序列号（针式）",
					value: false,
					field: "snNos"
				},
				"contactInfo": {
					text: "联系人电话地址",
					value: false,
					field: "contactInfo"
				}
			}
		}
	},
	"采购单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "采购单", //单据名称，默认为当前单据的名称
			showField: {
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputeName"
				},
				"discount": {
					text: "折扣率（折扣额）",
					value: true,
					field: ""
				},
				"warehouseName": {
					text: "入库仓库",
					value: true,
					field: "warehouseName"
				},
				"taxTotal": {
					text: "折后税额",
					value: true,
					field: "taxTotal"
				},
				"otherFee": {
					text: "其他费用",
					value: true,
					field: "otherFee"
				},
				"accountName": {
					text: "结算账户",
					value: true,
					field: "accountName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"productMemo": {
					text: "商品备注（针式）",
					value: false,
					field: "memo"
				},
				"propertySpec": {
					text: "规格，属性",
					value: true,
					field: ""
				},
				"barcode": {
					text: "商品编号/条形码",
					value: true,
					field: ""
				},
				"serial": {
					text: "序列号（针式）",
					value: false,
					field: "snNos"
				},
				"contactInfo": {
					text: "联系人电话地址",
					value: false,
					field: "contactInfo"
				}
			}
		}
	},
	"采购订单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "采购订单", //单据名称，默认为当前单据的名称
			showField: {
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputeName"
				},
				"discount": {
					text: "折扣率（折扣额）",
					value: true,
					field: ""
				},
				"warehouseName": {
					text: "入库仓库",
					value: true,
					field: "warehouseName"
				},
				"taxTotal": {
					text: "折后税额",
					value: true,
					field: "taxTotal"
				},
				"otherFee": {
					text: "其他费用",
					value: true,
					field: "otherFee"
				},
				"accountName": {
					text: "结算账户",
					value: true,
					field: "accountName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"productMemo": {
					text: "商品备注（针式）",
					value: false,
					field: "memo"
				},
				"propertySpec": {
					text: "规格，属性",
					value: true,
					field: ""
				},
				"barcode": {
					text: "商品编号/条形码",
					value: true,
					field: ""
				},
				"contactInfo": {
					text: "联系人电话地址",
					value: false,
					field: "contactInfo"
				}
			}
		}
	},
	"采购退货单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "采购退货单", //单据名称，默认为当前单据的名称
			showField: {
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputeName"
				},
				"discount": {
					text: "折扣率（折扣额）",
					value: true,
					field: ""
				},
				"warehouseName": {
					text: "出库仓库",
					value: true,
					field: "warehouseName"
				},
				"taxTotal": {
					text: "折后税额",
					value: true,
					field: "taxTotal"
				},
				"otherFee": {
					text: "其他费用",
					value: true,
					field: "otherFee"
				},
				"accountName": {
					text: "结算账户",
					value: true,
					field: "accountName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"productMemo": {
					text: "商品备注（针式）",
					value: false,
					field: "memo"
				},
				"propertySpec": {
					text: "规格，属性",
					value: true,
					field: ""
				},
				"barcode": {
					text: "商品编号/条形码",
					value: true,
					field: ""
				},
				"serial": {
					text: "序列号（针式）",
					value: false,
					field: "snNos"
				},
				"contactInfo": {
					text: "联系人电话地址",
					value: false,
					field: "contactInfo"
				}
			}
		}
	},
	"库存盘点单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "库存盘点单", //单据名称，默认为当前单据的名称
			showField: {
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputeName"
				},
				"warehouseName": {
					text: "盘点仓库",
					value: true,
					field: "warehouseName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"propertySpec": {
					text: "规格，属性",
					value: true,
					field: ""
				},
				"barcode": {
					text: "商品编号/条形码",
					value: true,
					field: ""
				}
			}
		}
	},
	"同价调拨单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "同价调拨单", //单据名称，默认为当前单据的名称
			showField: {
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputeName"
				},
				"otherFee": {
					text: "其他费用",
					value: true,
					field: "otherFee"
				},
				"accountName": {
					text: "结算账户",
					value: true,
					field: "accountName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"propertySpec": {
					text: "规格，属性",
					value: true,
					field: ""
				},
				"barcode": {
					text: "商品编号",
					value: true,
					field: ""
				},
				"serial": {
					text: "序列号（针式）",
					value: false,
					field: "snNos"
				}
			}
		}
	},
	"变价调拨单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "变价调拨单", //单据名称，默认为当前单据的名称
			showField: {
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputeName"
				},
				"otherFee": {
					text: "其他费用",
					value: true,
					field: "otherFee"
				},
				"accountName": {
					text: "结算账户",
					value: true,
					field: "accountName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"propertySpec": {
					text: "规格，属性",
					value: true,
					field: ""
				},
				"barcode": {
					text: "商品编号",
					value: true,
					field: ""
				},
				"serial": {
					text: "序列号（针式）",
					value: false,
					field: "snNos"
				}
			}
		}
	},
	"付款单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "付款单", //单据名称，默认为当前单据的名称
			showField: {
				"discountAmount": {
					text: "优惠",
					value: true,
					field: "discountAmount"
				},
				"accountName": {
					text: "结算账户",
					value: true,
					field: "accountName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputName"
				},
			}
		}
	},
	"收款单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "收款单", //单据名称，默认为当前单据的名称
			showField: {
				"discountAmount": {
					text: "优惠",
					value: true,
					field: "discountAmount"
				},
				"accountName": {
					text: "结算账户",
					value: true,
					field: "accountName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputName"
				},
			}
		}
	},
	"其他入库单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "其他入库单", //单据名称，默认为当前单据的名称
			showField: {
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputeName"
				},
				"warehouseName": {
					text: "入库仓库",
					value: true,
					field: "warehouseName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"productMemo": {
					text: "商品备注（针式）",
					value: false,
					field: "memo"
				},
				"propertySpec": {
					text: "规格，属性",
					value: true,
					field: ""
				},
				"barcode": {
					text: "商品编号/条形码",
					value: true,
					field: ""
				},
				"serial": {
					text: "序列号（针式）",
					value: false,
					field: "snNos"
				},
				"contactInfo": {
					text: "联系人电话地址",
					value: false,
					field: "contactInfo"
				}
			}
		}
	},
	"其他出库单": {
		useCommonConfig: true, //是否使用默认配置
		extendConfig: { //拓展配置
			fontScale: false, //部分字段放大显示
			billName: "其他出库单", //单据名称，默认为当前单据的名称
			showField: {
				"inputeName": {
					text: "制单人",
					value: true,
					field: "inputeName"
				},
				"warehouseName": {
					text: "出库仓库",
					value: true,
					field: "warehouseName"
				},
				"memo": {
					text: "备注",
					value: true,
					field: "memo"
				},
				"productMemo": {
					text: "商品备注（针式）",
					value: false,
					field: "memo"
				},
				"propertySpec": {
					text: "规格，属性",
					value: true,
					field: ""
				},
				"barcode": {
					text: "商品编号/条形码",
					value: true,
					field: ""
				},
				"serial": {
					text: "序列号（针式）",
					value: false,
					field: "snNos"
				},
				"contactInfo": {
					text: "联系人电话地址",
					value: false,
					field: "contactInfo"
				}
			}
		}
	},
	
}

/**
 * 根据模块名称获取模板名称
 * @param {Object} tplName 模块名称
 */
function getCurrentTpl(tplName) {
	var tpl = {};
	if(!window.plus) {
		return tpl;
	}
	var tplConfig = tplIndex[tplName];
	//先取一次默认值，方便版本升级，字段扩充
	if(tplConfig) {
		if(tplConfig["useCommonConfig"]) {
			mui.extend(tpl, commonConfig);
			mui.extend(tpl, tplConfig["extendConfig"]);
		} else {
			tpl = tplConfig["extendConfig"];
		}
	}
	
	var savedTpl = plus.storage.getItem("print_tpl");
	if(savedTpl) {
		savedTpl = JSON.parse(savedTpl);
		if(savedTpl && savedTpl[tplName]) {
			//兼容处理
			if(savedTpl[tplName]["showField"]["AccountName"]){
				savedTpl[tplName]["showField"]["accountName"] = savedTpl[tplName]["showField"]["AccountName"];
				delete savedTpl[tplName]["showField"]["AccountName"];
			}
			if(savedTpl[tplName]["showField"]["Barcode"]){
				savedTpl[tplName]["showField"]["barcode"] = savedTpl[tplName]["showField"]["Barcode"];
				delete savedTpl[tplName]["showField"]["Barcode"];
			}
			if(savedTpl[tplName]["showField"]["ContactInfo"]){
				savedTpl[tplName]["showField"]["contactInfo"] = savedTpl[tplName]["showField"]["ContactInfo"];
				delete savedTpl[tplName]["showField"]["ContactInfo"];
			}
			if(savedTpl[tplName]["showField"]["Discount"]){
				savedTpl[tplName]["showField"]["discount"] = savedTpl[tplName]["showField"]["Discount"];
				delete savedTpl[tplName]["showField"]["Discount"];
			}
			if(savedTpl[tplName]["showField"]["InputName"]){
				savedTpl[tplName]["showField"]["inputeName"] = savedTpl[tplName]["showField"]["InputName"];
				delete savedTpl[tplName]["showField"]["InputName"];
			}
			if(savedTpl[tplName]["showField"]["Memo"]){
				savedTpl[tplName]["showField"]["memo"] = savedTpl[tplName]["showField"]["Memo"];
				delete savedTpl[tplName]["showField"]["Memo"];
			}
			if(savedTpl[tplName]["showField"]["OtherFee"]){
				savedTpl[tplName]["showField"]["otherFee"] = savedTpl[tplName]["showField"]["OtherFee"];
				delete savedTpl[tplName]["showField"]["OtherFee"];
			}
			if(savedTpl[tplName]["showField"]["ProductMemo"]){
				savedTpl[tplName]["showField"]["productMemo"] = savedTpl[tplName]["showField"]["ProductMemo"];
				delete savedTpl[tplName]["showField"]["ProductMemo"];
			}
			if(savedTpl[tplName]["showField"]["PropertySpec"]){
				savedTpl[tplName]["showField"]["propertySpec"] = savedTpl[tplName]["showField"]["PropertySpec"];
				delete savedTpl[tplName]["showField"]["PropertySpec"];
			}
			if(savedTpl[tplName]["showField"]["Serial"]){
				savedTpl[tplName]["showField"]["serial"] = savedTpl[tplName]["showField"]["Serial"];
				delete savedTpl[tplName]["showField"]["Serial"];
			}
			if(savedTpl[tplName]["showField"]["serial"] && savedTpl[tplName]["showField"]["serial"]["field"] == "SnList"){
				savedTpl[tplName]["showField"]["serial"]["field"] = 'snNos';
			}
			if(savedTpl[tplName]["showField"]["WareName"]){
				savedTpl[tplName]["showField"]["warehouseName"] = savedTpl[tplName]["showField"]["WareName"];
				delete savedTpl[tplName]["showField"]["WareName"];
			}
			if(savedTpl[tplName]["showField"]["DiscountAmount"]){
				savedTpl[tplName]["showField"]["discountAmount"] = savedTpl[tplName]["showField"]["DiscountAmount"];
				delete savedTpl[tplName]["showField"]["DiscountAmount"];
			}
			if(savedTpl[tplName]["showField"]["TaxTotal"]){
				savedTpl[tplName]["showField"]["taxTotal"] = savedTpl[tplName]["showField"]["TaxTotal"];
				delete savedTpl[tplName]["showField"]["TaxTotal"];
			}
			tpl = mui.extend(true,{},tpl, savedTpl[tplName]); //读取已保存的模板 true 表示深度合并
		}
	}
	//alert(JSON.stringify(tpl))
	//如果没有保存，则读取默认值
	if(Object.getOwnPropertyNames(tpl).length == 0) {
		var tplConfig = tplIndex[tplName];
		if(tplConfig) {
			if(tplConfig["useCommonConfig"]) {
				mui.extend(tpl, commonConfig);
				mui.extend(tpl, tplConfig["extendConfig"]);
			} else {
				tpl = tplConfig["extendConfig"];
			}
		}
	}
	//更新变价调拨单和同价调拨单的文字
	if((tplName ==="同价调拨单" || tplName ==="变价调拨单") && tpl["showField"]["barcode"].text === "商品编号/条形码"){
		tpl["showField"]["barcode"].text = "商品编号"
	}
	return tpl;
}