document.addEventListener("plusready", function() {
    // 声明的JS“扩展插件别名”
    var ddhPluginAndroid =
        {

            // 声明异步返回方法 蓝牙打印
            bluetoothPrint : function (Argus,options, successCallback, errorCallback )
            {
                var success = typeof successCallback !== 'function' ? null : function(args)
                    {
                        successCallback(args);
                    },
                    fail = typeof errorCallback !== 'function' ? null : function(code)
                    {
                        errorCallback(code);
                    };
                var callbackID = window.plus.bridge.callbackId(success, fail);
                return window.plus.bridge.exec('ddhPluginAndroid', "bluetoothPrint", [callbackID, Argus],options);
            },
            // 声明异步返回方法 蓝牙打印（自动链接并打印）
            bluetoothPrintAuto : function (Argus,options, successCallback, errorCallback )
            {
                var success = typeof successCallback !== 'function' ? null : function(args)
                    {
                        successCallback(args);
                    },
                    fail = typeof errorCallback !== 'function' ? null : function(code)
                    {
                        errorCallback(code);
                    };
                var callbackID = window.plus.bridge.callbackId(success, fail);
                return window.plus.bridge.exec('ddhPluginAndroid', "bluetoothPrintAuto", [callbackID, Argus],options);
            },
            // 声明同步返回方法 获取获取已匹配设备
            getBondBluetooth : function (Argus)
            {

                return window.plus.bridge.execSync('ddhPluginAndroid', "getBondBluetooth", [Argus]);
            },
            // 声明同步返回方法 获取获取已匹配设备
            isHoneywell : function (Argus)
            {

                return window.plus.bridge.execSync('ddhPluginAndroid', "isHoneywell", [Argus]);
            },
        };
    window.plus.ddhPluginAndroid = ddhPluginAndroid;
}, true);

/**
 * 获取android打印数据（针式打印需要转换）
 * @param printData
 */
function getAndroidData(printDatas) {
    console.log("getAndroidData");

    if(printDatas==null){
       return null;
    }
    for (var key in printDatas) {
        var printData=printDatas[key];
        if(printData.type==="table"&&printData.data!=null){
            var data_printData_cur=[];
            for (var index in printData.data) {
                data_printData_cur.push({data:printData.data[index]});
            }
            printData.data=data_printData_cur;
        }
    }
    console.log(printDatas);
    return printData;
}
// var base64_test;//传base64给native 会闪退
// (function(){
//     //这是网上的一张图片链接
//     var url="http://p1.pstatp.com/large/435d000085555bd8de10";
//     getBase64(url,function(base64){
//         console.log(base64);//处理成功打印在控制台
//         base64_test=base64;
//     });
// })();
// //
// // //传入图片路径，返回base64
// function getBase64(img,callback){
//     function getBase64Image(img,width,height) {//width、height调用时传入具体像素值，控制大小 ,不传则默认图像大小
//         var canvas = document.createElement("canvas");
//         canvas.width = width ? width : img.width;
//         canvas.height = height ? height : img.height;
//
//         var ctx = canvas.getContext("2d");
//         ctx.drawImage(img, 0, 0, canvas.width, canvas.height);
//         var dataURL = canvas.toDataURL();
//         return dataURL;
//     }
//     var image = new Image();
//     image.crossOrigin = '';
//     image.src = img;
//     if(img){
//         image.onload =function (){
//             callback(getBase64Image(image));//将base64传给done上传处理
//         }
//     }
// }
