/**
 * 打开相机扫码页面
 * @param {Object} callbackListener  扫码回调的自定义事件字符串
 */
function openScanPage(callbackListener) {
	if(window.plus && callbackListener) {
		var waiting = plus.nativeUI.showWaiting()
		var openw = plus.webview.create(__PAGE_ROOT_PATH + 'pages/common/common_barcode_scan.html', 'common_barcode_scan.html',null,{'woListener':callbackListener});
		openw.addEventListener('loaded', function() { //页面加载完成后才显示
			//		setTimeout(function(){//延后显示可避免低端机上动画时白屏
			openw.show('pop-in');
			waiting.close();
			//		},200);
		}, false);
		openw.addEventListener('close', function() { //页面关闭后可再次打开
			openw = null;
		}, false);
	}
}