/**
 * 获取最新配置，更新本地缓存
 */
function getLatestDigitSettings(callback) {
	getNumberDigitSetting(function(result) {
		localStorage.setItem("_DigitSettings", JSON.stringify(result));
		if(callback!=null){
            callback(result);
		}
	});
}
var qtyDigit = 2; //数量小数点
var priceDigit = 2; //价格小数点

//刷新当前页面变量
(function initLocal() {
	var s = localStorage.getItem("_DigitSettings");
	if(s){
		s = JSON.parse(s);
		qtyDigit = s.qtydigit;
		priceDigit = s.pricedigit;
	}else{//在首页接口未调取成功，再次触发
		getLatestDigitSettings();
	}
})();

//配置template变量
window.template ? template.helper("getDigitSettings", function() {
	return {
		qtydigit: qtyDigit,
		pricedigit: priceDigit
	};
}) : "";