/*接口基础配置*/
var isDebug = false;
var __FORMAL_URL = 'https://mobile2.ddhing.com'; //ERP 正式环境//
var __TEST_URL = 'https://dev0.ddhing.com:9001'; //https://mobile.ddh.com:4036'; //ERP测试环境 https://d.ddhing.com:4036  http://d.ddhing.com:4037
var __PRD_URL = 'http://prdapp.ddhing.com'; //ERP prd环境
var __MALL_FORMAL_URL = 'https://fx.mobile.ddhing.com'; //mall 正式环境//https://fx.mobile.ddhing.com/
var __MALL_TEST_URL = 'https://dev0.ddhing.com:8283'; //mall 测试环境//http://fx.mobile.ddh.com:8285

var _requestDataType_json = 'application/json; charset=utf-8';
var _requestDataType_get = 'application/x-www-form-urlencoded';
/**》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》---------用户管理---------》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》**/
var _LOGIN_INVALID_MSG = '您的操作已超时或者账号已在其他终端登陆，需继续操作请重新登陆；如不是本人登陆，请及时修改密码';//登录失效提示信息
var _USERS_HISTORY = "ddh_users_history"; //登录过的账号列表
var _USER_INFO = "ddh_userInfo"; //缓存当前登录的用户信息
var _SESSION_KEY = "sessionKey"; //登录会话标示
var _PASSWORD = "password"; //密码
var _PAGE_LAST = "ddh_page_last"; //上一次离开页面
var _CREATETIME = "createTime"; //创建时间
var _EXPIREDATE = "expireTime"; //过期时间
var _ddh_use_app = "ddh_use_app"; //是否第一次使用app
// var _SYSTEM_OPTION="SystemOption";//商户系统配置
var _IsExperience = "IsExperience"; //是否是体验账号
var _BookId = "BookId"; //(integer, optional): 获取或设置账套id ,
var _UserName = "CustomerName"; //(string, optional): 获取或设置用户名(登录名，唯一，管理员初始为手机号码，可以修改) ,
var _UserRealName = "CustomerRealName"; //(string, optional): 获取或设置用户真实姓名 ,
var _UserId = "CustomerId"; //(integer, optional): 获取或设置用户id ,
var _IsOpenAccount = "IsOpenAccount"; //(string, optional): 是否开帐 ,0=否,1=是
var _PermissionItems = "PermissionItems"; //(string, optional): 用户权限 ,
var _Version = "Version"; //(string, optional);//: 版本信息 ,
var _EndDate = "EndDate"; //(string, optional);//: 服务到期日期 ,
var _IsTrial = "IsTrial"; //(boolean, optional);//: 是否试用 ,
var _IsAdminPermission = "HasAdminPurview"; //(boolean, optional, read only): 是否为管理员权限
var _IsAdmin = "IsAdmin"; //(boolean, optional, read only): 是否为主账号
var _Role = "Role"; //角色
var _CompanyInfo = "companyInfo"; //公司信息(登录没有返回,调用SysConfig/GetCompanyInfo接口后保存的)

/*常用方法集合*/
var common = {};
//////PAGE目录的上层目录www路径
var __PAGE_ROOT_PATH = location.href.substr(0, location.href.indexOf("pages"));
//列表无数据的提示
var __APP_LIST_NODATA = '<span class="app-list-nodata">暂无数据</span>';
(function() {
	window.app_userManage = {};
	app_userManage.getUserInfo_fromLocalStorage = function(key1, key2) {
		var str_user = localStorage.getItem(_USER_INFO);
		if(str_user != null) {
			var user = JSON.parse(str_user);
			if(key1 != null) {
				if(key2 != null) {
					if(user[key1] != null) {
						return user[key1][key2];
					} else {
						return null;
					}
				} else {
					return user[key1];
				}
			} else {
				return user;
			}
		} else {
			return null;
		}
	};
	/**
	 * 判断是否具有管理员权限
	 */
	app_userManage.hasAdminPermission = function(){
		return app_userManage.getUserInfo_fromLocalStorage(_IsAdminPermission) == 1 || app_userManage.getUserInfo_fromLocalStorage(_IsAdmin);
	}
	/**
	 *
	 * @param str_UserInfo
	 * @param isCover 是否全覆盖
	 */
	app_userManage.setUserInfo_toLocalStorage = function(str_UserInfo, isCover) {
		if(str_UserInfo != null) {

			if(!isCover) {
				/*本地数据持久*/
				var strUserLocal = localStorage.getItem(_USER_INFO);
				if(strUserLocal != null) {
					var userLocal = JSON.parse(strUserLocal);
                    if(typeof str_UserInfo === 'string') {
                        str_UserInfo=JSON.parse(str_UserInfo);
                    }
                    if(typeof str_UserInfo === 'object') {
                        str_UserInfo.bluetooth_print_addressInfo_android=userLocal.bluetooth_print_addressInfo_android
                    }
				}
			}
            if(typeof str_UserInfo === 'object') {
                str_UserInfo = JSON.stringify(str_UserInfo);
            }
		} else {
			str_UserInfo = "";
		}
		// console.log("setItem("+_USER_INFO+","+str_UserInfo+")");
		localStorage.setItem(_USER_INFO, str_UserInfo);
	};
	app_userManage.setUserProperty_toLocalStorage = function(key, value) {
		var str_user = localStorage.getItem(_USER_INFO);
		var result = false;
		var user;
		if(str_user != null) {
			user = JSON.parse(str_user);

		} else {
			user = new Object();
		}
		if(key != null) {
			if(value == null) {
				value = "";
			}
			user[key] = value;
			var strUserInfo = JSON.stringify(user);
			localStorage.setItem(_USER_INFO, strUserInfo);
			result = true;
		}
		return result;
	};
	/**
	 * 查看是否有对应的权限
	 * @param test 需要的权限对象或JSON字符串
	 * 例:单权限{"name":"Finance","actions":{"name":"VIEW","enable":true}}
	 * 多权限同时满足用数组, [{"name":"PURCHASE","actions":{"name":"VIEW","enable":true}},{"name":"SALE","actions":{"name":"VIEW","enable":true}}]
	 * 多权限只需满足其中之一,用"||"分割 {"name":"PURCHASE","actions":{"name":"VIEW","enable":true}}||{"name":"SALE","actions":{"name":"VIEW","enable":true}}
	 * @param isShowToast 是否提示无权限
	 * @param PermissionItemsCur 对比的权限(null时,默认去读localStorage)
	 * @returns {boolean} true=有权限
	 */
	app_userManage.hasPermission = function(objStr, isShowToast, PermissionItemsCur) {
		var hasPermission = true;
		var str_user = localStorage.getItem(_USER_INFO);
		var user;
		if(str_user != null) {
			user = JSON.parse(str_user);
			if(user["IsAdmin"]||user[_IsAdminPermission]==1) {
				hasPermission = true;
			} else if(objStr != null) {
				try {
					if(typeof objStr == "string" && objStr.indexOf("||") >= 0) {
						hasPermission = false;
						var objStrArr = objStr.split("||");
						for(index in objStrArr) {
							if(app_userManage.hasPermission(objStrArr[index], false, PermissionItemsCur)) {
								hasPermission = true;
								break;
							}
						}

					} else {
						var obj = typeof objStr == "string" ? JSON.parse(objStr) : objStr;
						// console.log(obj+":"+Object.prototype.toString(obj));
						if(Object.prototype.toString.call(obj) == '[object Array]') {
							for(index in obj) {
								if(!app_userManage.hasPermission(obj[index], false, PermissionItemsCur)) {
									hasPermission = false;
									break;
								}
							}
						} else if(Object.prototype.toString.call(obj) == '[object Object]') {
							if(PermissionItemsCur == null) {
								var PermissionItems = user[_PermissionItems];
								if(PermissionItems != null && PermissionItems instanceof Array) {
									for(var j = 0; j < PermissionItems.length; j++) {
										if(app_userManage.hasPermission(obj, false, PermissionItems[j])) {
											hasPermission = true;
											break;
										} else {
											hasPermission = false;
										}
									}
								}
							} else {
								var keys = Object.getOwnPropertyNames(obj);
								for(index in keys) {
									var value = obj[keys[index]];
									var valueSrc = PermissionItemsCur[keys[index].toLocaleLowerCase()];
									// console.log("prototype:"+Object.prototype.toString(value)+",value:"+value+",valueSrc:"+valueSrc);

									if(Object.prototype.toString.call(value) == '[object Object]') {
										if(Object.prototype.toString.call(valueSrc) == '[object Object]') {
											hasPermission = app_userManage.hasPermission(value, false, valueSrc);
											break;
										} else if(Object.prototype.toString.call(valueSrc) == '[object Array]') {
											hasPermission = false;
											for(var j = 0; j < valueSrc.length; j++) {
												if(app_userManage.hasPermission(value, false, valueSrc[j])) {
													hasPermission = true;
													break;
												}
											}
											if(!hasPermission) {
												break;
											}
										}

									} else if(Object.prototype.toString.call(value) == '[object Array]') {
										if(Object.prototype.toString.call(valueSrc) == '[object Array]') {
											for(var i = 0; i < value.length; i++) {
												for(var j = 0; j < valueSrc.length; j++) {
													if(!app_userManage.hasPermission(value[i], false, valueSrc[j])) {
														hasPermission = false;
														break;
													}
												}
											}
										} else {
											hasPermission = false;
											break;
										}

									} else {
                                        // console.log("value:" + value);
                                        // console.log("valueSrc:" + valueSrc);
										if(value != valueSrc) {/*.toLocaleUpperCase()*/
											hasPermission = false;
											break;
										}
									}
								}
							}
						}
					}

				} catch(e) {
					// hasPermission=true;
					console.log("objStr:" + objStr);
					console.log(e);
					// throw(e.name); //抛出异常
				}

			}
		}

		if(isShowToast && !hasPermission) {
			mui.toast("权限不足!(如果权限变动,请重新登录)");
		}
		return hasPermission;
	};
	/**
	 * 当前用户是否使用过app
	 * @returns {null}
	 */
	app_userManage.is_use_app = function() {
		return this.getUsersHistory(this.getUserInfo_fromLocalStorage()[_UserName], _ddh_use_app);

	};
	/**
	 * 获取登录的用户列表/单个用户/指定用户的属性
	 * @param UserName
	 * @param key
	 * @returns {null}
	 */
	app_userManage.getUsersHistory = function(UserName, key) {
		var isRefresh = false; //是否刷新数据(版本问题造成的数据存储结构变化时需要)
		var users = common.localStorageUtil.getItem(_USERS_HISTORY);
		if(users == null) { /*兼容1.1.4版本以前的代码*/
			users = localStorage.getItem(_USERS_HISTORY);
			if(users != null) { //typeof strusers == "string"
				isRefresh = true;
				users = JSON.parse(users);
				for(var i = 0; i < users.length; i++) {
					users[i] = {
						UserName: users[i]
					};
					users[i][_ddh_use_app] = false;
				}
				if(users.length > 0) {
					var is_use_app = localStorage.getItem(_ddh_use_app);
					if(is_use_app != null) {
						users[0][_ddh_use_app] = is_use_app;
					}
				}
			}
		}
		if(isRefresh) {
			this.saveUsersHistory(users);
		}
		if(UserName != null) {
			if(users != null && users.length > 0) {
				for(var i = 0; i < users.length; i++) {
					if(users[i].UserName == UserName) {
						if(key != null) {
							return users[i][key];
						} else {
							return users[i];
						}
					}
				}
			}
			return null;
		} else {
			return users;
		}

	};
	/**
	 * 添加用户到登录过的用户列表
	 * @param UserName
	 */
	app_userManage.addUserToUsersHistory = function(UserName) {
		var userInfo_0 = {
			UserName: UserName
		};
		userInfo_0[_ddh_use_app] = false;
		var users = app_userManage.getUsersHistory();
		if(users != null) {
			for(var i = 0; i < users.length;) {
				if(users[i].UserName == UserName) {
					userInfo_0[_ddh_use_app] = users[i][_ddh_use_app];
					users.splice(i, 1);
				} else {
					i++
				}
			}
		}
		if(!(users instanceof Array)) {
			users = [];
		}
		users.unshift(userInfo_0);
		common.localStorageUtil.setItem(_USERS_HISTORY, users);

	};
	/**
	 * 保存登录过的用户列表
	 * @param UsersHistory
	 */
	app_userManage.saveUsersHistory = function(UsersHistory) {
		common.localStorageUtil.setItem(_USERS_HISTORY, UsersHistory);
	};
	/**
	 * 编辑用户列表数据
	 * @param UserName
	 * @param key
	 * @param value
	 */
	app_userManage.updateUsersHistory = function(UserName, key, value) {
		var users = app_userManage.getUsersHistory();
		if(users != null) {
			for(var i = 0; i < users.length; i++) {
				if(users[i].UserName == UserName) {
					users[i][key] = value;
					break;
				}
			}
		}
		this.saveUsersHistory(users);
	};
}());

/**
 *操作限制判断(0无限制,1未登录,2未开户)
 */
function operateAstrict(isShowToast) {
	var canOperate;
	// console.log(JSON.stringify(app_userManage.getUserInfo_fromLocalStorage()));
	if(app_userManage.getUserInfo_fromLocalStorage() != null) {
		// console.log(!app_userManage.getUserInfo_fromLocalStorage(_IsOpenAccount));
		if(!app_userManage.getUserInfo_fromLocalStorage(_IsOpenAccount)) {
			// console.log("未开帐不能使用此功能");
			canOperate = 2;
			if(isShowToast) {
				mui.toast("未开帐不能使用此功能!(如果已经开账,请重新登录)");
			}
		} else {
			canOperate = 0;
		}
	} else {
		canOperate = 1;
		if(isShowToast) {
			mui.toast("您还未登录");
		}

	}

	return canOperate;
}

/**
 * 设置iOS顶部通知栏背景色
 * @param appType 1=分销,2=采购
 */
function setStatusBarColor() {
	if(mui.os.ios && window.plus) {
		var appType = localStorage.getItem(_PAGE_LAST);
		var backgroundColor;
		var statusBarStyle;
		if(appType == "2") {
			//采购
			backgroundColor = '#ff4545';
			// statusBarStyle = 'UIStatusBarStyleDefault'; //黑色文字
			statusBarStyle = 'UIStatusBarStyleBlackOpaque'; //白色文字
		} else {
			//分销
			backgroundColor = '#0D7AD9';
			statusBarStyle = 'UIStatusBarStyleBlackOpaque'; //白色文字

		}
		plus.navigator.setStatusBarBackground(backgroundColor);
		plus.navigator.setStatusBarStyle(statusBarStyle)
	}
}

function setThemeColor() {
	var appType = localStorage.getItem(_PAGE_LAST);
	var body = document.querySelector("body");
	if(!!body) {
		if(appType == "2") {
			//采购
			if(!body.classList.contains("theme-purchaser")) {
				body.classList.add("theme-purchaser");
				body.classList.remove("theme-provider");
			}
		} else {
			//分销
			if(!body.classList.contains("theme-provider")) {
				body.classList.add("theme-provider");
				body.classList.remove("theme-purchaser");
			}
		}
	}
}
/**
 * 打开新页面
 * @param {Object} pageUrl
 */
var lastTime = 0;
var _LAST_EXTRAS = "last_extras";
var _STR_EXTRAS = "strExtras";
var default_openNewPage = {
	'pageUrl': '',
	'extras': null,
	'createNew': false,
	'closeWebView': false,
	'popGesture': 'close'
};

function openNewPage(_Config, _extras, _createNew) {
	var Config_cur = {};
	if(typeof(_Config) == "object") {
		Config_cur = _Config;
	} else if(typeof(_Config) == "string") {
		Config_cur.pageUrl = _Config;
		if(_extras != null) {
			Config_cur.extras = _extras;
		}
		if(_createNew != null) {
			Config_cur.createNew = _createNew;
		}
	}

	Config_cur = mui.extend({}, default_openNewPage, Config_cur);
	// console.log("window.plus:" + window.plus + ";mui.os.plus:" + mui.os.plus + ";mui.os.ios:" + mui.os.ios + ";mui.os.android:" + mui.os.android);
	if(Config_cur.pageUrl.indexOf("?") >= 0) {
		Config_cur.pageUrl += "&time=" + new Date().getTime();
	} else {
		Config_cur.pageUrl += "?time=" + new Date().getTime();
	}
	var canOpenNewPage = false;
	if(mui.os.plus) {
		if(window.plus) {
			lastTime = 0;
			canOpenNewPage = true;
			if(Config_cur.extras != null) {
				Config_cur.extras["strExtras"] = JSON.stringify(Config_cur.extras);
			}
		} else {
			var curTime = new Date().getTime();
			if(lastTime == 0 || curTime - lastTime < 3 * 1000) {
				setTimeout(function() {
					openNewPage(Config_cur.pageUrl, Config_cur.extras);
				}, 300);
			} else {
				lastTime = 0
			}
		}
	} else {
		canOpenNewPage = true;
	}
	// console.log("canOpenNewPage:" + canOpenNewPage);
	if(canOpenNewPage) {
        // console.log("Config_cur:" + JSON.stringify(Config_cur));
		// console.log("pageUrl:" + Config_cur.pageUrl);
		if(Config_cur.createNew == null) {
			Config_cur.createNew = false;
		}
		// console.log("id:" + Config_cur.pageUrl.substring(Config_cur.pageUrl.lastIndexOf("/") + 1, Config_cur.pageUrl.lastIndexOf(".")));
		mui.openWindow({
			url: Config_cur.pageUrl,
			id: Config_cur.pageUrl.substring(Config_cur.pageUrl.lastIndexOf("/") + 1, Config_cur.pageUrl.lastIndexOf(".")),
			styles: {
				popGesture: Config_cur.popGesture // 'close'
			},
			softinputMode:'adjustResize',
			extras: Config_cur.extras,
			createNew: Config_cur.createNew, //是否重复创建同样id的webview，默认为false:不重复创建，直接显示
			show: {
//				aniShow: 'pop-in',
				duration: 150
			},
			waiting: {
				autoShow: false
			},
		});
		if(!mui.os.plus) {
			//saveStrToSession("strExtras",Config_cur.extras);
			if(Config_cur.extras != null) {
				if(typeof(Config_cur.extras) != "string") {
					Config_cur.extras = JSON.stringify(Config_cur.extras);
				}
				sessionStorage.setItem("strExtras", Config_cur.extras);
			}
		} else {
			if(window.plus) {
				console.log("Config_cur.closeWebView:" + Config_cur.closeWebView);
				if(Config_cur.closeWebView) {
					setTimeout(function() {
						var ws = plus.webview.currentWebview();
						console.log("close:" + ws);
						plus.webview.close(ws);
					}, 800);
				}
			}
		}
	}
}
//恢复进入页面前的缓存参数
function recover_last_extras(Extras) {
	if(Extras != null) {
		if(Extras[_LAST_EXTRAS] != null) {
			if(!mui.os.plus) {
				sessionStorage.setItem(_STR_EXTRAS, Extras[_LAST_EXTRAS]);
			}
		} else {
			if(!mui.os.plus) {
				sessionStorage.removeItem(_STR_EXTRAS);
			}
		}
	}
}
var _IS_SHOW_RELOGIN = "isShowReLogin";
/**
 * 发送异步ajax请求
 * @param config 配置参数
 * config.requestUri  请求地址
 * config.requestSuccessCallback  请求成功后的回调函数：函数接受数据参数
 * config.requestFailCallback   请求失败后的回调函数：函数接受数据参数
 * config.requestData   请求携带的数据
 */
var defaultWebRequestConfig = {
	'requestUri': '',
	'requestType': 'get',
	'requestData': {},
	//"requestContentType": 'application/json; charset=utf-8',//application/x-www-form-urlencoded
	"requestProcessData":true,
	"responseDataType": 'json',
	'requestShowLoading': true, //是否显示加载框
	'requestTimeout': 60000,
	'shadeClose': true, //显示加载框时 是否点击遮罩时关闭层
	'getDataFromAPICallback': null, //接口数据的回调(若返回true则不执行跳过code、msg处理)
	'manageCode': false, //处理code
	'showMsgLalout': null, //显示处理code结果(处理code时才使用)
	'showMessageType': 4, //显示Message方式,默认1=只显示异常code,2=都显示，3=不显示,4=即使code=0但是Success=false时也提示
	'requestSuccessCallback': function(data, status, xhr) {},
	'requestFailCallback': function(xhr, type, errorThrown) {},
	"mallManage":false
};
var indexWaitingCount = 0;
var indexWaiting_last;

function sendConfigRequest(config) {
	var requestParams = mui.extend({}, defaultWebRequestConfig, config);
	var rootPath = isDebug ? __TEST_URL : __FORMAL_URL;
	if(requestParams.mallManage){
		rootPath = isDebug ? __MALL_TEST_URL : __MALL_FORMAL_URL;
	}
	var rootPathApi = rootPath + "/api";
	if(requestParams.requestType.toLowerCase() == "get") {
		if(requestParams.requestUri.indexOf("?") >= 0) {
			requestParams.requestUri += "&time=" + new Date().getTime();
		} else {
			requestParams.requestUri += "?time=" + new Date().getTime();
		}
	}
	var postHeaders = {};
	var SessionKey = app_userManage.getUserInfo_fromLocalStorage(_SESSION_KEY);
	if(SessionKey && SessionKey != '') {
		postHeaders["sessionKey"] = SessionKey;
	}
	if(mui.os.android) {
		postHeaders.AppKey = "72b7c8e3b3854668a2d5b04f61add104";
	} else if(mui.os.ios) {
		postHeaders.AppKey = "c8a21b361f114de1b34a54c7b5d6ccdd";
	} else {
		postHeaders.AppKey = "2b23dce10ba745c98d4d38cfdbe83bd4";
	}
	postHeaders.TimeStamp = new Date().getTime().toString().substr(0, 10);
	if(requestParams.requestType.toLowerCase()=='post'&&requestParams.requestContentType==null){
        requestParams.requestContentType = _requestDataType_json
    }
	mui.ajax(rootPathApi + requestParams.requestUri, {
		data: requestParams.requestContentType == _requestDataType_json ? JSON.stringify(requestParams.requestData) : requestParams.requestData,
		type: requestParams.requestType.toUpperCase(),
		dataType: requestParams.responseDataType,
		contentType: requestParams.requestContentType,
        // processData:requestParams.requestProcessData,
		timeout: requestParams.requestTimeout,
		crossDomain: true,
		headers: postHeaders,
		success: function(data, status, xhr) {
//			 console.log("success data:"+JSON.stringify(data)+";status:"+status+";xhr:"+xhr);
			console.log("success status:"+status);
			if(requestParams.requestShowLoading) {
				closeWaiting(indexWaiting_last);
			}
			switch(data["Code"] ||data["code"]) {
				case 401:
					var showMessage = data["Message"] || data["message"];
					if(showMessage == null) {
						showMessage = _LOGIN_INVALID_MSG;
					}
					alert_relogin(showMessage);
					return;
			}
			requestParams.requestSuccessCallback(data, status, xhr);
			if(requestParams.getDataFromAPICallback == null || !requestParams.getDataFromAPICallback(data["Data"]||data["data"], data["Success"]||data["success"], data["Message"]||data["message"], data["Code"]||data["code"])) {
				manageCodeMsg(requestParams, data);
			}
		},
		beforeSend: function() {
			console.log("beforeSend Uri:"+rootPathApi + requestParams.requestUri);
			if(requestParams.requestShowLoading) {
				indexWaiting_last = showWaiting(requestParams.shadeClose);
			}

		},
		error: function(xhr, type, errorThrown) {
			 console.log("error xhr:"+xhr+";type:"+type+";errorThrown:"+errorThrown);
			if(requestParams.requestShowLoading) {
				closeWaiting(indexWaiting_last);
			}
			requestParams.requestFailCallback(xhr, type, errorThrown);
			if(xhr.status == 401) {
				alert_relogin(null);
			} else {
				if(type == 'abort') {
					mui.toast(errorThrown ? errorThrown : '请求失败，请确认当前网络环境是否正常');
				} else if(type == 'timeout') {
					mui.toast(errorThrown ? errorThrown : '网络连接超时，请检查网络或稍后再试');
				} else {
					mui.toast(type + ":" + errorThrown);
				}
			}
		},
	});
}

/**
 * 发送异步ajax请求
 * @param _urlString 请求地址URI，不含域名
 * @param _type      请求类型："get" 或 "post"
 * @param _callback  请求成功后的回调函数：函数接受数据参数
 * @param _data      参数传递
 * @param _requestShowLoading     是否显示加载框
 */
function sendRequest(_urlString, _type, _callback, _data, _requestShowLoading) {
	sendConfigRequest({
		'requestUri': _urlString,
		'requestType': _type,
		'requestSuccessCallback': _callback,
		'requestData': _data,
		'requestShowLoading': _requestShowLoading,
	})
}

function manageCodeMsg(requestParams, data) {
	if(requestParams.manageCode && data != null && data["Code"] != null) {
		var showMessage = data["Message"];
		var showMsgLalout_innerHTML;
		switch(data["Code"]) {
			case 0:
				if(data["Success"] == true) {
					if(showMessage == null) {
						showMessage = "操作成功";
					}
				} else {
					if(showMessage == null) {
						showMessage = "操作失败";
					}
				}
				break;
			case 400:
				if(showMessage == null) {
					showMessage = "提交数据无效,验证未通过";
				}
				break;
			case 401:
				if(showMessage == null) {
					showMessage = _LOGIN_INVALID_MSG;
				}
                if(requestParams.requestShowLoading) {
                    closeWaiting(indexWaiting_last);
                }
				alert_relogin(showMessage);
				return;
			case 429:
				if(showMessage == null) {
					showMessage = "请求太频繁";
				}
				break;

			case 500:
				if(showMessage == null) {
					showMessage = "内部错误";
				}
				break;

			case 4003:
				if(showMessage == null) {
					showMessage = "您的权限不足";
				}
				showMsgLalout_innerHTML = HAS_NO_RIGHT_TIPS;
				break;
			default:

				break
		}
		switch(requestParams.showMessageType) {
			case 1:
				if(data["Code"] != 0) {
					mui.toast(showMessage);
				}
				break;
			case 2:
				mui.toast(showMessage);
				break;
			case 3:
				break;
			case 4:
				if(data["Code"] != 0 || !data["Success"]) {
					if(showMessage != null && showMessage != "") {
						mui.toast(showMessage);
					}
				}
				break;
			default:
				break
		}
		if(requestParams.showMsgLalout != null && showMsgLalout_innerHTML != null) {
			requestParams.showMsgLalout.innerHTML = showMsgLalout_innerHTML;
		}
	}
}
//处理接口返回的数据，并返回有效数据
function getData_succeed(data, getIsSuccess) {
	var Result = null;
	if(data != null) {
		switch(data.Code) {
			case 0:
				if(data.success == true) {
					if(getIsSuccess) {
						Result = data.success;
					} else {
						Result = data.data;
					}
				} else {
					if(getIsSuccess) {
						Result = data.success;
					}
					if(data.message != null) {
						mui.toast(data.message);
					} else {
						mui.toast("请求数据失败");
					}
				}
				break;
			case 429:
				if(data.message != null) {
					mui.toast(data.message);
				} else {
					mui.toast("请求太频繁");
				}
				break;
			case 401:
				alert_relogin(data.message);
				return;
			case 500:
				if(data.message != null) {
					mui.toast(data.message);
				} else {
					mui.toast("内部错误");
				}
				break;
			case 400:
				if(data.message != null) {
					mui.toast(data.message);
				} else {
					mui.toast("提交数据无效,验证未通过");
				}
				break;
			case 4003:
				if(data.message != null) {
					mui.toast(data.message);
				} else {
					mui.toast("您的权限不足!");
				}
				break;
			default:

				break
		}
	}

	return Result;
}

function showWaiting(shadeClose) {
	//console.log("layer.open");
	indexWaitingCount++;
	return layer.open({
		type: 2,
		shade: true,
		shadeClose: shadeClose,
	});

}

function closeWaiting(index) {
	//console.log("layer.close");
	indexWaitingCount--;
	if(indexWaitingCount == 0) {
		layer.close(index);
		indexWaiting_last = 0;
	}

}

/**
 * 数字格式化
 * @param {Object} 数字
 * @param {Object} 精度
 * @param {Object} 小数点符
 * @param {Object} 千分符
 */
function numberFormat(number, decimals, decPoint, thousandsSep) {
	//   example 1: numberFormat(1234.56);
	//   returns 1: '1,235'
	//   example 2: numberFormat(1234.56, 2, ',', ' ');
	//   returns 2: '1 234,56'
	//   example 3: numberFormat(1234.5678, 2, '.', '');
	//   returns 3: '1234.57'
	//   example 4: numberFormat(67, 2, ',', '.');
	//   returns 4: '67,00'
	//   example 5: numberFormat(1000);
	//   returns 5: '1,000'
	//   example 6: numberFormat(67.311, 2);
	//   returns 6: '67.31'
	//   example 7: numberFormat(1000.55, 1);
	//   returns 7: '1,000.6'
	//   example 8: numberFormat(67000, 5, ',', '.');
	//   returns 8: '67.000,00000'
	//   example 9: numberFormat(0.9, 0);
	//   returns 9: '1'
	//  example 10: numberFormat('1.20', 2);
	//  returns 10: '1.20'
	//  example 11: numberFormat('1.20', 4);
	//  returns 11: '1.2000'
	//  example 12: numberFormat('1.2000', 3);
	//  returns 12: '1.200'
	//  example 13: numberFormat('1 000,50', 2, '.', ' ');
	//  returns 13: '100 050.00'
	//  example 14: numberFormat(1e-8, 8, '.', '');
	//  returns 14: '0.00000001'
	number = (number + '').replace(/[^0-9+\-Ee.]/g, '');
	var n = !isFinite(+number) ? 0 : +number,
		prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
		sep = (typeof thousandsSep === 'undefined') ? ',' : thousandsSep,
		dec = (typeof decPoint === 'undefined') ? '.' : decPoint,
		s = '',
		toFixedFix = function(n, prec) {
			var k = Math.pow(10, prec);
			return '' + (Math.round(n * k) / k).toFixed(prec);
		};
	// Fix for IE parseFloat(0.55).toFixed(0) = 0;
	s = (prec ? toFixedFix(n, prec) : '' + Math.round(n))
		.split('.');
	if(s[0].length > 3) {
		s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
	}
	if((s[1] || '')
		.length < prec) {
		s[1] = s[1] || '';
		s[1] += new Array(prec - s[1].length + 1)
			.join('0');
	}
	return s.join(dec);
}
/**
 * 把格式化的number字符串转化为number类型
 * @param {Object} v 数字或数字字符串
 * @param
 */
function formatNumWithDigit(v,digit) {
	var _digit = digit?Number(digit):2;
	return Number(numberFormat(v, _digit, '.', ''));
}
/**
 * 四舍五入(解决numbertoFixedFix(0.0056,2)=0.00类似问题)
 * @param number
 * @param decimals
 * @returns {string}
 */
function numbertoFixedFix(number, decimals) {
	var k = Math.pow(10, decimals);
	return(Math.round(number * k) / k).toFixed(decimals);
}
var _not_select = "not_select";
/**
 * 页面返回数据（web时保存到sessionStorage,app时触发当前页面名字的自定义函数）
 * @param data
 */
function page_return_result(data, _Config, saveKey) {
	if(data != null) {
		// console.log("data"+data);
		// console.log("JSON.stringify(data):"+JSON.stringify(data));
		// console.log("JSON.stringify(_Config):"+JSON.stringify(_Config));
		var Config_cur;
		if(typeof(_Config) == "object") {
			Config_cur = _Config;
		} else if(typeof(_Config) == "string") {
			Config_cur = {
				'webviewById': _Config,
				'webviewById_fire': _Config,
				'saveKey': saveKey,
			};
		}
		if(Config_cur==null){
            Config_cur={}
		}
		var url = location.href;
		var page_name = url.substring(url.lastIndexOf("/") + 1, url.lastIndexOf("."));
		if(mui.os.plus) {
			console.log("Config_cur['webviewById']:" + Config_cur["webviewById"]);
			if(window.plus && Config_cur["webviewById"] != null) {
				var parentPage = plus.webview.getWebviewById(Config_cur["webviewById"]);
				if(Config_cur["webviewById_fire"] == null) {
					Config_cur["webviewById_fire"] = Config_cur["saveKey"] != null ? Config_cur["saveKey"] : page_name;
				}
				console.log("parentPage,Config_cur['webviewById_fire'],data:" + parentPage + "," + Config_cur["webviewById_fire"] + "," + data);
				mui.fire(parentPage, Config_cur["webviewById_fire"], {
					"data": data
				});
			}
		} else {
			if(Config_cur["saveKey"] == null) {
				Config_cur["saveKey"] = Config_cur["webviewById_fire"] != null ? Config_cur["webviewById_fire"] : page_name;
			}
			if(typeof data == "string") {
				sessionStorage.setItem(Config_cur["saveKey"], data);
			} else {
				sessionStorage.setItem(Config_cur["saveKey"], JSON.stringify(data));
			}
		}
	}
}
/**
 * 在非plus设备上删除清除sessionStorage中指定项
 * @param arr
 */
function remove_sessionStorage_NOplus(arr) {
	if(!mui.os.plus) {
		remove_sessionStorage(arr);
	}

}

function remove_sessionStorage(arr) {
	if(arr != null) {
		if(typeof(arr) == "string") {
			sessionStorage.removeItem(arr);
		} else {
			for(var index in arr) {
				sessionStorage.removeItem(arr[index]);
			}
		}
	}
}

function remove_localStorage(arr) {
	if(arr != null) {
		if(typeof(arr) == "string") {
			localStorage.removeItem(arr);
		} else {
			for(var index in arr) {
				localStorage.removeItem(arr[index]);
			}
		}

	}
}

function alert_relogin(_msg) {
	var msg = _msg != null ? _msg : _LOGIN_INVALID_MSG;
	//if(localStorage.getItem(_IS_SHOW_RELOGIN)!=1){
	//    localStorage.setItem(_IS_SHOW_RELOGIN,1);
	mui.alert(msg, '', function() {
		relogin();
		//localStorage.setItem(_IS_SHOW_RELOGIN,0);
	}, "div");
	//}
}
/**
 * 重新登录
 */
function relogin() {
	sessionStorage.clear();
	var page_last = localStorage.getItem(_PAGE_LAST);
	var users_history = app_userManage.getUsersHistory();
	var ddh_use_app = localStorage.getItem(_ddh_use_app); /*兼容1.1.4版本以前的代码*/
	localStorage.clear();
    if(page_last != null && page_last != undefined) {
        localStorage.setItem(_PAGE_LAST, page_last);
    }
	if(!!users_history) {
		if(!!ddh_use_app && users_history.length > 0) { /*兼容1.1.4版本以前的代码*/
			users_history[0][_ddh_use_app] = ddh_use_app;
		}
		app_userManage.saveUsersHistory(users_history);

	}

	//清空与推送相关的所有消息
	//清空是否隐藏新手向导配置
	if(window.plus) {
		//推送
		plus.runtime.setBadgeNumber(0);
		plus.push.clear();

		//向导
		plus.storage.removeItem("hidden_index_guide");
	}
	//清除小数点位数缓存
	localStorage.removeItem("_DigitSettings");

	var rootPagePath = location.href.substr(0, location.href.indexOf("pages"));
	openNewPage({
		'pageUrl': rootPagePath + 'pages/common/user/login.html',
		'extras': null,
		'popGesture': 'none'
	});
}

function closeWebView() {
	console.log("closeWebView()");
	if(mui.os.plus) {
		if(window.plus) {
			// logWebView();
			var url = location.href;
			var page_name = url.substring(url.lastIndexOf("/") + 1, url.lastIndexOf("."));
			console.log("page_name:" + page_name);
			var wvs = plus.webview.all();
			for(var i = 0; i < wvs.length; i++) {
				try {
					console.log("getPageNameFromWebview wvs[" + i + "].getURL():" + getPageNameFromWebview(wvs[i]));
					if(wvs[i] != null && wvs[i].getURL() != null) {
						try {
							if(wvs[i].getURL().indexOf(page_name) == -1 ) {//&& wvs[i] != plus.webview.getLaunchWebview()
                                if(isDisplayWebview(wvs[i])){
                                    (function(webView){
                                        setTimeout(function () {
                                            console.log("延迟关闭："+getPageNameFromWebview(webView)+".close");
                                            webView.close(false, 0);
                                        },800);
                                    }(wvs[i]));
                                }else {
                                    console.log(wvs[" + i + "]+".close");
                                    wvs[i].close(false, 0);
                                }
							}
						} catch(e) {
							console.log(e);
						}
					}
				} catch(error) {
					console.log(error);
				}
			}
		}
	}
}

function closeOtherWebView() {
	console.log("closeOtherWebView()");
	if(mui.os.plus && window.plus) {
		var url_current = location.href;
		var page_name_current = url_current.substring(url_current.lastIndexOf("/") + 1, url_current.lastIndexOf("."));
		console.log("page_name_current:" + page_name_current);
        console.log("plus.webview.getLaunchWebview().getURL():" + getPageNameFromWebview(plus.webview.getLaunchWebview()));
		//var holdWebview=getHoldWebview();
		var wvs = plus.webview.all();
		for(var i = 0; i < wvs.length; i++) {
			try {
				var pageName = getPageNameFromWebview(wvs[i]);
				console.log("webview[" + i + "] pageName:"+pageName);
				//loglistChildren(wvs[i]);
				if(pageName != null && pageName.length > 0) {
					try {
						/*不关闭当前页面) */
						if(pageName != page_name_current ) {
							/*&&!isContain(holdWebview, wvs[i]) && pageName != "index"*/
							/*延迟关闭启动当前页面的页面(经测试，IOS如果在plusReady调用，
							plus.webview.all()列表里面还没有当前页面，
							关闭上一个页面会导致当前页面加载异常(白屏)*/

							if(wvs[i].parent() != null) {
								var pageName_parent = getPageNameFromWebview(wvs[i].parent());
								if(pageName_parent != page_name_current ) {// && pageName_parent != "index"

                                    if(isDisplayWebview(wvs[i])){
                                        console.log("800毫秒后关闭："+getPageNameFromWebview(wvs[i])+".close");
                                        (function(webView){
                                            setTimeout(function () {
                                                console.log("延迟关闭："+webView);
                                                console.log("延迟关闭："+getPageNameFromWebview(webView)+".close");
                                                webView.close("none", 0);
                                            },800);
                                        }(wvs[i]));
                                    }else {
                                        console.log(pageName+".close");
                                        wvs[i].close("none", 0);
                                    }
								} else {//不关闭子页面
									console.log(pageName+".not close");
								}
							} else {
                                if(isDisplayWebview(wvs[i])){
                                    console.log("800毫秒后关闭："+getPageNameFromWebview(wvs[i])+".close");
                                    (function(webView){
                                        setTimeout(function () {
                                            console.log("延迟关闭："+webView);
                                            console.log("延迟关闭："+getPageNameFromWebview(webView)+".close");
                                            webView.close("none", 0);
                                        },800);
                                    }(wvs[i]));
                                }else {
                                    console.log(pageName+".close");
                                    wvs[i].close("none", 0);
                                }
							}

						}
					} catch(e) {
						console.log("异常：wvs[" + i + "] pageName:" + pageName);
						console.log(e);
					}
				}
			} catch(error) {
				console.log(error);
			}
		}
	}
}
// 获取子Webview窗口
function loglistChildren(webview) {
	if(webview != null) {
		var list = webview.children();
		for(var i = 0; i < list.length; i++) {
			console.log("webview.getURL():" + webview.getURL() + "Children[" + i + "]: " + list[i].getURL());
		}
	}
}

function getPageNameFromWebview(webview) {
	//console.log("getPageNameFromWebview()");
	var pagename = "";
	if(webview != null) {
		var url = webview.getURL();
		if(url != null) {
			pagename = url.substring(url.lastIndexOf("/") + 1, url.lastIndexOf(".html"))
		}
	}
	return pagename;
}
function isDisplayWebview(webview) {
	var isDisplay=false;
    var displayWebviews=plus.webview.getDisplayWebview();
    for(var i = 0; i < displayWebviews.length; i++) {
        console.log("DisplayWebview displayWebviews[" + i + "] pageName:"+getPageNameFromWebview(displayWebviews[i]));
        if(webview==displayWebviews[i]){
            isDisplay=true;
            break;
		}
    }
    return isDisplay;
}

//控制按钮点击效果
(function() {
	var selectorCur = '.auto_app_tap_style';
    mui("body").on("touchstart", selectorCur, function(e) {
        // console.log("touchstart");
        if(this.classList != null) {
            this.classList.add("app_tap_style");
        } else {
            this.className = "app_tap_style";
        }
    });
    mui("body").on("touchend", selectorCur, function(e) {
        // console.log("touchend");
        this.classList.remove("app_tap_style");
    });
    mui("body").on("touchcancel", selectorCur, function(e) {
        // console.log("touchcancel");
        this.classList.remove("app_tap_style");
    });

	////////////////临时解决iOS11沉浸式状态栏问题开始//////////////
	var plusReadyFunction = function(){
		if(window.plus){
			var web = plus.ios.currentWebview();
			var scr = plus.ios.getAttribute(web, "scrollView");
			plus.ios.setAttribute(scr, "contentInsetAdjustmentBehavior", "0");
		}
	};
	if(window.plus) {
		plusReadyFunction();
	} else {
		document.addEventListener('plusready', plusReadyFunction, false);
	}
	// 监听DOMContentLoaded事件
	document.addEventListener('DOMContentLoaded', function() {
		plusReadyFunction();
	}, false);
	////////////////临时解决iOS11沉浸式状态栏问题结束//////////////
	//	mui.os.android && document.querySelector('.mui-title')?document.querySelector('.mui-title').style.lineHeight='42px':'';
}());
var SYSTEM_MAX_NUMBER = 9999999999.99; //系统支持的最大数值
//无权限代码
var NO_PERMISSION_CODE = 4003;
var HAS_NO_RIGHT_TIPS = '<div style="height: 300px;background: url(../../img/has_no_right.svg) no-repeat;background-size: 130px 130px;background-position:center 70px;position: relative;">' +
	'<span style="position: absolute;top: 200px;text-align: center;display: block;width: 100%;color: #999;line-height: 40px;font-size: 15px;">亲，权限不足哦！</span></div>';
(function(win, com, mui) {
    var sessionStorageUtil = {};

    sessionStorageUtil.getItem = function(k) {
        var jsonStr = window.sessionStorage.getItem(k.toString());
        return jsonStr ? JSON.parse(jsonStr).data : null;
    };
    sessionStorageUtil.setItem = function(k, value) {
        value = JSON.stringify({
            data: value
        });
        k = k.toString();
        try {
            window.sessionStorage.setItem(k, value);
        } catch(e) {
            console.log(e);
        }
    };

    function getLength() {
        return window.sessionStorage.length;
    };
    sessionStorageUtil.getLength = getLength;


    function removeItem(k) {
        return window.sessionStorage.removeItem(k);
    };

    sessionStorageUtil.removeItem = function(k) {
        window.sessionStorage.removeItem(k);
    }
    sessionStorageUtil.clear = function() {
        window.sessionStorage.clear();
    };

    function key(index) {
        return window.sessionStorage.key(index);
    };
    sessionStorageUtil.key = key;


    function getItemByIndex(index) {
        var item = {
            keyname: '',
            keyvalue: ''
        };
        item.keyname = sessionStorageUtil.key(index);
        item.keyvalue = sessionStorageUtil.getItem(item.keyname);
        return item;
    };
    sessionStorageUtil.getItemByIndex = getItemByIndex;

    /**
     * @description 获取所有存储对象
     * @param {Object} key 可选，不传参则返回所有对象，否则返回含有该key的对象
     */
    sessionStorageUtil.getItems = function(k) {
        var items = [];
        var numKeys = getLength();
        var numKeysPlus = getLengthPlus();
        var i = 0;
        if(k) {
            for(; i < numKeys; i++) {
                if(key(i).toString().indexOf(k) != -1) {
                    items.push(getItemByIndex(i));
                }
            }
            for(i = 0; i < numKeysPlus; i++) {
                if(keyPlus(i).toString().indexOf(k) != -1) {
                    items.push(getItemByIndexPlus(i));
                }
            }
        } else {
            for(i = 0; i < numKeys; i++) {
                items.push(getItemByIndex(i));
            }
            for(i = 0; i < numKeysPlus; i++) {
                items.push(getItemByIndexPlus(i));
            }
        }
        return items;
    };
    /**
     * @description 清除指定前缀的存储对象
     * @param {Object} keys
     * @default ["filePathCache_","ajax_cache_"]
     */
    sessionStorageUtil.removeItemByKeys = function(keys, cb) {
        if(typeof(keys) === "string") {
            keys = [keys];
        }
        var numKeys = getLength();
        //TODO plus.storage是线性存储的，从后向前删除是可以的
        //稳妥的方案是将查询到的items，存到临时数组中，再删除
        var tmpks = [];
        var tk,
            i = numKeys - 1;
        for(; i >= 0; i--) {
            tk = key(i);
            Array.prototype.forEach.call(keys, function(k, index, arr) {
                if(tk.toString().indexOf(k) != -1) {
                    tmpks.push(tk);
                }
            });
        }
        tmpks.forEach(function(k) {
            removeItem(k);
        });
        cb && cb();
    };
    com.sessionStorageUtil = sessionStorageUtil;
    win.sessionStorageUtil = sessionStorageUtil;
}(window, common, mui));
(function(win, com, mui) {
    /**
     * 在使用plus.storage频繁地存取数据时，可以感觉到明显的卡顿，而且很耗内存，
     在切换到localstorage时虽然效率很高，页面渲染速度明显变快了，且手机发热不明显，不过又遇到了存储瓶颈（一般<=5M）,
     因此折中采取了plus.storage与localStorage混合的方案：
     当localStorage达到存储瓶颈时切换到plus.storage
     * @description 本地存储
     */
    var localStorageUtil = {};

    function getItem(k) {
        var jsonStr = window.localStorage.getItem(k.toString());
        return jsonStr ? JSON.parse(jsonStr).data : null;
    };

    function getItemPlus(k) {
        var jsonStr = mui.os.plus && window.plus ? plus.storage.getItem(k.toString()) : null;
        return jsonStr ? JSON.parse(jsonStr).data : null;
    };
    localStorageUtil.getItem = function(k) {
        return getItem(k) || getItemPlus(k);
    };
    localStorageUtil.setItem = function(k, value) {
        value = JSON.stringify({
            data: value
        });
        k = k.toString();
        try {
            window.localStorage.setItem(k, value);
        } catch(e) {
            console.log(e);
            //TODO 超出localstorage容量限制则存到plus.storage中
            //且删除localStorage重复的数据
            removeItem(k);
            mui.os.plus ? plus.storage.setItem(k, value) : null;
        }
    };

    function getLength() {
        return window.localStorage.length;
    };
    localStorageUtil.getLength = getLength;

    function getLengthPlus() {
        return mui.os.plus ? plus.storage.getLength() : null;
    };
    localStorageUtil.getLengthPlus = getLengthPlus;

    function removeItem(k) {
        return window.localStorage.removeItem(k);
    };

    function removeItemPlus(k) {
        return mui.os.plus ? plus.storage.removeItem(k) : null;
    };
    localStorageUtil.removeItem = function(k) {
        window.localStorage.removeItem(k);
        return mui.os.plus ? plus.storage.removeItem(k) : null;
    }
    localStorageUtil.clear = function() {
        window.localStorage.clear();
        return mui.os.plus ? plus.storage.clear() : null;
    };

    function key(index) {
        return window.localStorage.key(index);
    };
    localStorageUtil.key = key;

    function keyPlus(index) {
        return mui.os.plus ? plus.storage.key(index) : null;
    };
    localStorageUtil.keyPlus = keyPlus;

    function getItemByIndex(index) {
        var item = {
            keyname: '',
            keyvalue: ''
        };
        item.keyname = key(index);
        item.keyvalue = getItem(item.keyname);
        return item;
    };
    localStorageUtil.getItemByIndex = getItemByIndex;

    function getItemByIndexPlus(index) {
        var item = {
            keyname: '',
            keyvalue: ''
        };
        item.keyname = keyPlus(index);
        item.keyvalue = getItemPlus(item.keyname);
        return item;
    };
    localStorageUtil.getItemByIndexPlus = getItemByIndexPlus;
    /**
     * @description 获取所有存储对象
     * @param {Object} key 可选，不传参则返回所有对象，否则返回含有该key的对象
     */
    localStorageUtil.getItems = function(k) {
        var items = [];
        var numKeys = getLength();
        var numKeysPlus = getLengthPlus();
        var i = 0;
        if(k) {
            for(; i < numKeys; i++) {
                if(key(i).toString().indexOf(k) != -1) {
                    items.push(getItemByIndex(i));
                }
            }
            for(i = 0; i < numKeysPlus; i++) {
                if(keyPlus(i).toString().indexOf(k) != -1) {
                    items.push(getItemByIndexPlus(i));
                }
            }
        } else {
            for(i = 0; i < numKeys; i++) {
                items.push(getItemByIndex(i));
            }
            for(i = 0; i < numKeysPlus; i++) {
                items.push(getItemByIndexPlus(i));
            }
        }
        return items;
    };
    /**
     * @description 清除指定前缀的存储对象
     * @param {Object} keys
     * @default ["filePathCache_","ajax_cache_"]
     */
    localStorageUtil.removeItemByKeys = function(keys, cb) {
        if(typeof(keys) === "string") {
            keys = [keys];
        }
        var numKeys = getLength();
        var numKeysPlus = getLengthPlus();
        //TODO plus.storage是线性存储的，从后向前删除是可以的
        //稳妥的方案是将查询到的items，存到临时数组中，再删除
        var tmpks = [];
        var tk,
            i = numKeys - 1;
        for(; i >= 0; i--) {
            tk = key(i);
            Array.prototype.forEach.call(keys, function(k, index, arr) {
                if(tk.toString().indexOf(k) != -1) {
                    tmpks.push(tk);
                }
            });
        }
        tmpks.forEach(function(k) {
            removeItem(k);
        });
        for(i = numKeysPlus - 1; i >= 0; i--) {
            tk = keyPlus(i);
            Array.prototype.forEach.call(keys, function(k, index, arr) {
                if(tk.toString().indexOf(k) != -1) {
                    tmpks.push(tk);
                }
            });
        }
        tmpks.forEach(function(k) {
            removeItemPlus(k);
        })
        cb && cb();
    };
    com.localStorageUtil = localStorageUtil;
    win.localStorageUtil = localStorageUtil;
}(window, common, mui));
