/**
 * Created by 0000 on 16/11/21.
 */
var indexWaiting;
/**
 * H5压缩
 */
function resizeImageWeb(reSizeConfig){
    indexWaiting=showWaiting(true);
    console.log("indexWaiting:"+indexWaiting);
    var defaultConfig = {
        'path': '',//图片路径
        // 'FileName': '',//图片名字
        // 'os': '',//运行环境
        'getDataFromAPICallback': function (data, status, xhr) {
        },
        'requestFailCallback': function (xhr, type, errorThrown) {
        }
    };
    var reSizeConfigUse;
    if (typeof(reSizeConfig) == "object") {
        reSizeConfigUse = mui.extend({}, defaultConfig, reSizeConfig);
    } else if (typeof(reSizeConfig) == "string") {
        reSizeConfigUse={};
        reSizeConfigUse.path = reSizeConfig;
    }else {
        return;
    }
    // console.log("reSizeConfig.FileName:"+reSizeConfigUse.FileName);
    // console.log("reSizeConfigUse.path:"+reSizeConfigUse.path);
    var img = new Image();
    img.src = reSizeConfigUse.path;        // 传过来的图片路径在这里用。
    img.onload = function () {
        if(reSizeConfigUse.os=="ios"){
            EXIF.getData(img, function() {
                // console.log(EXIF.pretty(this));
                var Orientation = EXIF.getTag(this, "Orientation");
                console.log("Orientation:"+Orientation);
                // console.log("Orientation==6:"+(Orientation==6));
                var base64=getResizeBase64ByImg(this,Orientation);
                   console.log("base64.length:"+base64.length);
                var FileName=reSizeConfigUse.FileName!=null?reSizeConfigUse.FileName:reSizeConfigUse.path.substring(reSizeConfigUse.path.lastIndexOf("/")+1);
                FileName=FileName.toLowerCase( );
                // console.log("FileName:"+FileName);
                // console.log("base64.length:"+base64.length);
                var requestData={"FileName":FileName,"FileData":base64};
                var APIFunctionConfig= mui.extend({}, reSizeConfigUse);
                APIFunctionConfig.requestData=requestData;
                APIPostImageFile(APIFunctionConfig);
            });

        }else {
            var base64=getResizeBase64ByImg(this,1);
            // 把base64数据丢过去，上传要用。
            // var pic = document.getElementById("x");
            // pic.src = base64;                    //这里丢到img 的 src 里面就能看到效果了
            console.log("base64.length:"+base64.length);
            var FileName=reSizeConfigUse.FileName!=null?reSizeConfigUse.FileName:reSizeConfigUse.path.substring(reSizeConfigUse.path.lastIndexOf("/")+1);
            FileName=FileName.toLowerCase( );
            // console.log("FileName:"+FileName);
            // console.log("base64.length:"+base64.length);
            var requestData={"FileName":FileName,"FileData":base64};
            var APIFunctionConfig= mui.extend({}, reSizeConfigUse);
            APIFunctionConfig.requestData=requestData;
            APIPostImageFile(APIFunctionConfig);
            // if(mui.os.plus&&window.plus) {
            // 	saveImg2gallery(canvas);
            // }
        }


    }

}
function getResizeBase64ByImg(img,Orientation,max_wh) {
    var max=max_wh?max_wh:1200;
    var that = img;
    //生成比例
    var w = that.width,
        h = that.height,
        scale = w / h;
    console.log("that.width："+that.width+"，that.height:"+that.height);
    if(w>h){
        w = Math.min(max, w);
        h = Math.round(w / scale);
    }else {
        h = Math.min(max, h);
        w = Math.round(h*scale);
    }
    //生成canvas
    var canvas = document.createElement('canvas');

    var ctx = canvas.getContext('2d');
    console.log("max_wh："+max_wh+"，width:"+w+",height:"+h);
    canvas.setAttribute("width",w);
    canvas.setAttribute("height",h);
    ctx.drawImage(that, 0, 0, w, h);

    if(Orientation != "" && Orientation != 1){
        // console.log('旋转处理');
        switch(Orientation){
            case 6://需要顺时针（向左）90度旋转
                // console.log('需要顺时针（向左）90度旋转');
                rotateImg(that,'left',canvas);
                break;
            case 8://需要逆时针（向右）90度旋转
                // console.log('需要顺时针（向右）90度旋转');
                rotateImg(that,'right',canvas);
                break;
            case 3://需要180度旋转
                console.log('需要180度旋转');
                rotateImg(that,'right',canvas);//转两次
                rotateImg(that,'right',canvas);
                break;
        }
    }
    var base64=canvas.toDataURL('image/jpg', 1  );   //1最清晰，越低越模糊。有一点不清楚这里明明设置的是jpeg。弹出 base64 开头的一段 data：image/png;却是png。
    console.log("base64.length:"+base64.length);
    // for (var i=1;base64.length>100000;i=i-0.1){
    //     base64=getResizeBase64ByImg(img,1,max*0.8);
    //     console.log("循环压缩 i："+i+"---base64.length:"+base64.length);
    // }
    return base64;
    // console.log(base64);

}
//对图片旋转处理 added by lzk
function rotateImg(img, direction,canvas) {
    //console.log(img);
    //最小与最大旋转方向，图片旋转4次后回到原方向
    var min_step = 0;
    var max_step = 3;
    //var img = document.getElementById(pid);
    if (img == null)return;
    //img的高度和宽度不能在img元素隐藏后获取，否则会出错
    var height = img.height;
    var width = img.width;
    //var step = img.getAttribute('step');
    var step = 2;
    if (step == null) {
        step = min_step;
    }
    if (direction == 'right') {
        step++;
        //旋转到原位置，即超过最大值
        step > max_step && (step = min_step);
    } else {
        step--;
        step < min_step && (step = max_step);
    }
    //img.setAttribute('step', step);
    /*var canvas = document.getElementById('pic_' + pid);
     if (canvas == null) {
     img.style.display = 'none';
     canvas = document.createElement('canvas');
     canvas.setAttribute('id', 'pic_' + pid);
     img.parentNode.appendChild(canvas);
     }  */
    //旋转角度以弧度值为参数
    var degree = step * 90 * Math.PI / 180;
    var ctx = canvas.getContext('2d');
    switch (step) {
        case 0:
            canvas.width = width;
            canvas.height = height;
            ctx.drawImage(img, 0, 0);
            break;
        case 1:
            canvas.width = height;
            canvas.height = width;
            ctx.rotate(degree);
            ctx.drawImage(img, 0, -height);
            break;
        case 2:
            canvas.width = width;
            canvas.height = height;
            ctx.rotate(degree);
            ctx.drawImage(img, -width, -height);
            break;
        case 3:
            canvas.width = height;
            canvas.height = width;
            ctx.rotate(degree);
            ctx.drawImage(img, -width, 0);
            break;
    }
}
/**
 * 图片上传(base64数据)
 * @param config
 * @constructor
 */
function APIPostImageFile(config) {
    var defaultConfig = {
        'requestData': '',//图片base64数据和文件名
        // 'size': '100',//图片显示路径,可空
        'getDataFromAPICallback': function (data, status, xhr) {
        },
        'requestFailCallback': function (xhr, type, errorThrown) {
        }
    };
    var configUse;
    if (typeof(config) == "object") {
        configUse = mui.extend({}, defaultConfig, config);
    }else {
        return;
    }
    // configUse.requestData.maxWidth=1000;
    // console.log("configUse.requestData:"+configUse.requestData);
    console.log("configUse.requestData.FileName:"+configUse.requestData.FileName);
    console.log("configUse.requestData.FileData.length:"+configUse.requestData.FileData.length);
    // console.log("configUse.requestData.FileData:"+configUse.requestData.FileData);
      console.log("0----------");
    var formData=getFormData(configUse.requestData.FileName,configUse.requestData.FileData);
      console.log("1----------");
    /*原生ajax*/
    var xhr = null; //得到xhr对象
    if(XMLHttpRequest){
        xhr = new XMLHttpRequest();
    }else{
        xhr = new ActiveXObject("Microsoft.XMLHTTP");
    }
	  console.log("----------");
    xhr.open("post", "https://d.ddhing.com:4036/api/Upload/UploadItemImg?maxWidth=1200", true);//设置提交方式，url，异步提交
    
   
    var SessionKey = app_userManage.getUserInfo_fromLocalStorage(_SESSION_KEY);
	if(SessionKey && SessionKey != '') {
		xhr.setRequestHeader("sessionKey", SessionKey);
	}
	if(mui.os.android) {
		 xhr.setRequestHeader("AppKey", "72b7c8e3b3854668a2d5b04f61add104");
	} else if(mui.os.ios) {
		 xhr.setRequestHeader("AppKey", "c8a21b361f114de1b34a54c7b5d6ccdd");
	} else {
		 xhr.setRequestHeader("AppKey", "2b23dce10ba745c98d4d38cfdbe83bd4");
	}
    xhr.setRequestHeader("TimeStamp",new Date().getTime().toString().substr(0, 10));
    xhr.onload = function ()
    {
    	  console.log("3----------");
        var data = xhr.responseText;    //得到返回值
             console.log("----------data:"+data);
        var responseData = JSON.parse(data);
             console.log("----------responseData.msg:"+responseData.msg);
        if(configUse.getDataFromAPICallback(responseData.data, responseData.Success, responseData.Message, responseData.Code)){
            return true;
        }
        closeWaiting(indexWaiting);
        console.log("indexWaiting:"+indexWaiting);

    }
    xhr.onerror = function (xhr, type, errorThrown)
    {
        closeWaiting(indexWaiting);
        console.log("indexWaiting:"+indexWaiting);
        console.log("requestFailCallback errorThrown:"+errorThrown);

    };
    xhr.send(formData);
    return;
    //*jquery*/
    // $.ajax({
    //     url: 'https://d.ddhing.com:4036/api/Upload/UploadItemImg?maxWidth=1200' ,
    //     type: 'POST',
    //     data: formData,
    //     async: false,
    //     cache: false,
    //     contentType: false,
    //     processData: false,
    //     beforeSend: function(request) {
    //         request.setRequestHeader("sessionKey", "5a0a57212f134e13b46d00f0eba0d36a");
    //         request.setRequestHeader("AppKey", "c8a21b361f114de1b34a54c7b5d6ccdd");
    //         request.setRequestHeader("TimeStamp",new Date().getTime().toString().substr(0, 10));
    //     },
    //     success: function (returndata) {
    //         alert(returndata);
    //     },
    //     error: function (returndata) {
    //         alert(returndata);
    //     }
    // });
    // return;
    // sendConfigRequest({
    //     'requestUri': '/Upload/UploadItemImg?maxWidth=1200',
    //     'requestType': 'post',
    //     'requestContentType':"multipart/form-data",
    //     'requestData': formData,//configUse.requestData,
    //     'requestProcessData':false,
    //     'requestShowLoading':false,
    //     'getDataFromAPICallback': function(data, Success, Message, Code) {
    //         // console.log("JSON.stringify(data):"+JSON.stringify(data));
    //         if(configUse.getDataFromAPICallback(data, Success, Message, Code)){
    //             return true;
    //         }
    //         if(indexWaitings.length>0){
    //             indexWaiting=indexWaitings.pop();
    //         }
    //         if(indexWaitings.length==0){
    //             indexWaitings=[];
    //             layer.closeAll();
    //         }
    //         console.log("pop indexWaitings.length:"+indexWaitings.length);
    //         return false;
    //     },
    //     'manageCode': true,
    //     'requestFailCallback': function(xhr, type, errorThrown) {
    //         // closeWaiting(indexWaiting);
    //         // layer.closeAll();
    //         // indexWaiting=indexWaitings.pop();
    //         // closeWaiting(indexWaiting);
    //         if(indexWaitings.length>0){
    //             indexWaiting=indexWaitings.pop();
    //         }
    //         if(indexWaitings.length==0){
    //             indexWaitings=[];
    //             layer.closeAll();
    //         }
    //         console.log("pop indexWaitings.length:"+indexWaitings.length);
    //         console.log("requestFailCallback errorThrown:"+errorThrown);
    //     }
    // });
}

/**
 * 将base64转换成二进制图片（Blob）
 * @param base64Data
 * @returns {*}
 */
function dataURItoBlob(base64Data) {
    var byteString;
    if (base64Data.split(',')[0].indexOf('base64') >= 0)
        byteString = atob(base64Data.split(',')[1]);
    else
        byteString = unescape(base64Data.split(',')[1]);
    var mimeString = base64Data.split(',')[0].split(':')[1].split(';')[0];
    var ia = new Uint8Array(byteString.length);
    for (var i = 0; i < byteString.length; i++) {
        ia[i] = byteString.charCodeAt(i);
    }
    return new Blob([ia], {type:mimeString});
}

/**
 * 通过base64获取 构造的formData数据
 * @param imageBase64
 * @returns {*}
 */
function getFormData(fileName,imageBase64) {
    var blob = dataURItoBlob(imageBase64); // 上一步中的函数
    var canvas = document.createElement('canvas');
    // var dataURL = canvas.toDataURL('image/jpeg', 0.5);
    // var formData = new FormData(document.forms[0]);
    var formData = new FormData();
    formData.append("file", blob, fileName);
    return formData;
}
