/**
 *页面输入框input获取焦点后自动全选 
 */
;
!(function() {
	var originHeight = window.innerHeight;
	window.addEventListener('resize', function(e) {
		if(window.innerHeight == originHeight) {
			document.activeElement.blur();
		} else {
			if(window.myScroll) {
				setTimeout(function() {
//					var activeElement = document.activeElement;
//					myScroll.scrollToElement(activeElement);
//					activeElement.focus();
				}, 200);
			}
		}
	});
	document.querySelector('body').addEventListener('focusin', function(e) {
		var _target = e.target;
		if(_target.classList.contains('qy-number-input')) {
			_target.select();
			if(mui.os.ios) {
				setTimeout(function() {
					_target.setSelectionRange(0,9999);
					//miniRefresh?miniRefresh.scrollTo(_target.offsetParent.offsetTop,100):'';
					//_target.selectionStart = 0;
					//_target.selectionEnd = _target.value.length;
				}, 100);
			} else {
				setTimeout(function() {
					//console.log(document.documentElement.scrollTop - getOffsetTop(_target))
					window.miniRefresh?miniRefresh.scrollTo(_target.offsetParent.offsetTop,100):'';
					mui('.mui-scroll-wrapper').length > 0 ?mui('.mui-scroll-wrapper').scroll().scrollTo(0, document.documentElement.scrollTop - Number(getOffsetTop(_target))):'';
				}, 100);
			}
		}
	}, false);

	/**
	 * 获取offsetTop高度
	 * @param {Object} obj
	 */
	function getOffsetTop(obj) {
		if(obj.offsetTop != 0) {
			return obj.offsetTop;
		} else if(obj.offsetParent) {
			return getOffsetTop(obj.offsetParent);
		} else {
			return obj.offsetTop;
		}
	}
})();