/////模版辅助函数注册
template.helper('getOrderPaymentStatus', function(flag) {
	return getOrderPaymentStatus(flag);
})
template.helper('getOrderDeliverStatus', function(flag) {
	return getOrderDeliverStatus(flag);
})
template.helper('getOrderShippingType', function(flag) {
	return getOrderShippingType(flag);
})
template.helper('getOrderStatus', function(flag) {
	return getOrderStatus(flag);
})
template.helper('getInvoiceType', function(flag) {
	return getInvoiceType(flag);
})
template.helper('numberFormat', function(number, decimals, decPoint, thousandsSep) {
	return numberFormat(number, decimals, decPoint, thousandsSep);
})
template.helper('getYearFromDateStr', function(dateStr) {
	return getYearFromDateStr(dateStr);
})
template.helper('getDayFromDateStr', function(dateStr) {
	return getDayFromDateStr(dateStr);
});
template.helper('handleDate', function(dateStr) {
	return handleDate(dateStr);
});
template.helper('getPaymentStatus', function(status,channel) {
	return getPaymentStatus(status,channel);
});
template.helper('getGoodsReturnStatus', function(status) {
	return getGoodsReturnStatus(status);
});
template.helper('getGoodsReturnLogs', function(flag) {
	return getGoodsReturnLogs(flag);
});
template.helper('isSelfShipping', function(code) {
	return isSelfShipping(code);
});
template.helper('getGoodsReturnShippingType', function(flag) {
	return getGoodsReturnShippingType(flag);
});
template.helper('authorityCheckUpdated', function(flag) {
	return authorityCheckUpdated(flag);
});
template.helper('getPromotionTypeText', function(flag) {
	return getPromotionTypeText(flag);
});
template.helper('getPromotionTypeClass', function(flag) {
	return getPromotionTypeClass(flag);
});
/**
 * 获取年份字符串
 * @param {Object} dateStr
 * 返回格式{year:----,day:-----}
 */
function getYearFromDateStr(dateStr) {
	if (!dateStr) {
		return '----';
	}
	var dayAndTime = dateStr.split(' ');
	var day = dayAndTime[0].split('-');
	return day[0];;
}

function getDayFromDateStr(dateStr) {
	if (!dateStr) {
		return '-----';
	}
	var dayAndTime = dateStr.split(' ');
	var day = dayAndTime[0].split('-');
	return day[1] + '-' + day[2];
}

function handleDate(str) {
	if(!str){
		return '-'
	}
	var strArray = str.split(" ");
	if(strArray[1] && strArray[1]=='00:00:00'){
		return strArray[0];
	}
	return str;
}

function isSelfShipping(code) {
	if(code && code=='_selfshipping'){
		return true;
	}
	return false;
}
